// -*- coding: cp932 -*-

#include "stdafx.h"

class Person
{
public:
    Person() {
        printf("[%08X]Person.ctor\r\n", (uintptr_t)this);
    }
    virtual ~Person() {
        printf("[%08X]Person.dtor\r\n", (uintptr_t)this);
    }
    void say() {
        printf("[%08X]hello!!\r\n", (uintptr_t)this);
    }

    Person* getThisAsPointer() {
        return this;
    }
    Person& getThisAsReference() {
        return *this;
    }
};

BOOST_PYTHON_MODULE(person)
{
    using namespace boost::python;

    class_<Person>("Person", "<<< document here >>>")
        .def("say", &Person::say)
        .def("getThisAsPointer", &Person::getThisAsPointer, return_value_policy<return_opaque_pointer>())
        .def("getThisAsReference", &Person::getThisAsReference, return_internal_reference<>());
}

