// -*- coding: cp932 -*-

#include "stdafx.h"

class Person
{
public:
    Person() {
    }
    virtual ~Person() {
    }
    void say() {
        printf("[%08X]%s\n", (uintptr_t)this, _what());
    }

    virtual const char* _what() const {
        return "person!!";
    }
};

struct PersonWrapper : Person, boost::python::wrapper<Person>
{
    virtual const char* _what() const {
        if(boost::python::override func = get_override("_what")){
            return func();
        }
        return Person::_what();
    }
};

BOOST_PYTHON_MODULE(person)
{
    using namespace boost;
    using namespace boost::python;

    class_<PersonWrapper, noncopyable>("Person", "<<< document here >>>")
        .def("say", &Person::say);
}

