//	shive's code 2008.09.30
//=============================================================================

#include "stdafx.h"
#include "chunk.h"
#include "debug.h"
#include "file.h"
#include <time.h>

#define A2P( THIS, ADR ) if(THIS&&THIS->ADR){((THIS->ADR) = (chunk*)((uintptr_t)(THIS) + *(uint32*)&(THIS->ADR)));}
#define P2A( THIS, PTR ) if(THIS&&THIS->PTR){(*(uint32*)&(THIS->PTR) = (uint32)((uintptr_t)(THIS->PTR) - (uintptr_t)(THIS)));}

#pragma warning( disable : 4505 )	//QƂĂȂ[J֐͍폜܂B
#pragma warning( disable : 4706 )	//̔rĺǍʂɂȂĂ܂B

namespace shive { namespace com {

	template<typename T>
	static void traverse( chunk* root, T* context, void(T::*func)(chunk*) )
	{
		chunk* stack[ 32 ] = {root};
		chunk** stacktop = stack + 1;
		do{
			--stacktop;
			chunk* cc = *stacktop;
			do{
				if(cc->next()){
					*stacktop = cc->next();
					++stacktop;
				}
				(context->*func)(cc);
			}while(cc = cc->child());
		} while( stacktop != stack );
	}

	struct ChunkPair {
		chunk* chk;
		chunk* parent;
	};

	template<typename T>
	static void traverse( chunk* root, T* context, void(T::*func)(ChunkPair*) )
	{
		ChunkPair stack[ 32 ] = {{root,0}};
		ChunkPair* stacktop = stack + 1;
		do{
			--stacktop;
			ChunkPair pair = *stacktop;
			do{
				if(pair.chk->next()){
					stacktop->chk = pair.chk->next();
					stacktop->parent = pair.parent;
					++stacktop;
				}
				(context->*func)(&pair);
				pair.parent = pair.chk;
			}while(pair.chk = pair.chk->child());
		} while( stacktop != stack );
	}

	struct writer_t
	{
		uint32 size;
		byte* buf;
		byte* ptr;

		void totalsize( chunk* chk )
		{
			size += chk->headersize();
			size += chk->datasize();
		}

		chunk* write( chunk* chk )
		{
			if(!chk){
				return 0;
			}
			chunk* ret = (chunk*)ptr;
			memcpy(ptr,chk,chk->size());
			ptr += chk->size();
			ret->SetChild( write( chk->child() ) );
			ret->SetNext( write( chk->next() ) );
			return ret;
		}
	};

	static time_t _buildtimestamp()
	{
		tm when;
		memset(&when,0,sizeof(when));

		char buf[32];
		sscanf(__DATE__,"%s %d %d",buf,&when.tm_mday,&when.tm_year);
		sscanf(__TIME__,"%d:%d:%d",&when.tm_hour,&when.tm_min,&when.tm_sec);
		when.tm_year -= 1900;

		if(!_stricmp(buf,"jan")){
			when.tm_mon = 0;
		} else
		if(!_stricmp(buf,"Feb")){
			when.tm_mon = 1;
		} else
		if(!_stricmp(buf,"Mar")){
			when.tm_mon = 2;
		} else
		if(!_stricmp(buf,"Apr")){
			when.tm_mon = 3;
		} else
		if(!_stricmp(buf,"May")){
			when.tm_mon = 4;
		} else
		if(!_stricmp(buf,"Jun")){
			when.tm_mon = 5;
		} else
		if(!_stricmp(buf,"Jul")){
			when.tm_mon = 6;
		} else
		if(!_stricmp(buf,"Aug")){
			when.tm_mon = 7;
		} else
		if(!_stricmp(buf,"Sep")){
			when.tm_mon = 8;
		} else
		if(!_stricmp(buf,"Oct")){
			when.tm_mon = 9;
		} else
		if(!_stricmp(buf,"Nov")){
			when.tm_mon = 10;
		} else
		if(!_stricmp(buf,"Dec")){
			when.tm_mon = 11;
		}

		return mktime(&when);
	}
	static time_t buildtimestamp()
	{
		static time_t s_buildtimestamp = _buildtimestamp();
		return s_buildtimestamp;
	}

	void chunk::SaveAs( const char* outpath )
	{
		filechunk file;
		file.Reset();
		file.chunk.AddChunk( this );
		file.buildtimestamp = (uint32)buildtimestamp();

		writer_t writer;
		memset(&writer,0,sizeof(writer));
		writer.size = 0;
		traverse( &file.chunk, &writer, &writer_t::totalsize );
		file.filesize = writer.size;

		writer.buf = new byte[ writer.size ];
		memset(writer.buf,0,writer.size);
		writer.ptr = writer.buf;
		writer.write(&file.chunk);

		file::write(outpath,writer.buf,writer.size);

		delete[] writer.buf;
	}

}}
