//	shive's code 2008.09.30
//=============================================================================

#pragma once
#include "../types.h"

#pragma pack( push, 4 )

namespace shive { namespace com {

	//! oCif[^`N
	struct chunk
	{
		static inline uint32 ID( uint32 N ) {
			return ((N>>24)|((N>>8)&0xFF00)|((N&0xFF00)<<8)|((N&0xFF)<<24));
		}

		uint32 tag;
		uint16 ver;
		union {
			struct {
				uint16 _alignment : 3;
			} _attr;
			uint16 _attrbits;
		};
		union {
			struct {
				uint32 _header : 8;
				uint32 _data : 24;
			} _size;
			uint32 _sizebits;
		};
		uint32 _child;
		uint32 _next;

		//! childCfNXwŎ擾
		chunk* operator [] ( int index ) {
			chunk* cc = child();
			for(; cc && index > 0; --index ){
				cc = cc->next();
			}
			return cc;
		}

		int alignment() const {
			return (1 << (_attr._alignment + 2));
		}
		void SetAlignment( int size ) {
			int align = -2;
			size >>= 1;
			while( size ){
				size >>= 1;
				++align;
			}
			assert(align >= 0);
			_attr._alignment = align;
		}

		uint32 headersize() const {
			return (_size._header << 2);
		}
		void SetHeaderSize( uint32 newsize ) {
			_size._header = (newsize + (1<<2) - 1) >> 2;
		}
		uint32 datasize() const {
			return (_size._data << 2);
		}
		void SetDataSize( uint32 newsize ) {
			_size._data = (newsize + (1<<2) - 1) >> 2;
		}
		byte* data() {
			return _size._data? (byte*)this + headersize(): 0;
		}
		uint32 size() const {
			return (headersize() + datasize());
		}

		chunk* child() {
			return _child? (chunk*)((uintptr_t)this + _child): 0;
		}
		void SetChild( chunk* chunk ) {
			_child = chunk? (uintptr_t)chunk - (uintptr_t)this: 0;
		}
		chunk* next() {
			return _next? (chunk*)((uintptr_t)this + _next): 0;
		}
		void SetNext( chunk* chunk ) {
			_next = chunk? (uintptr_t)chunk - (uintptr_t)this: 0;
		}

		chunk* Find( uint32 tag ) {
			chunk* iter = child();
			while(iter){
				if( iter->tag == tag ){
					return iter;
				}
				iter = iter->next();
			}
			return 0;
		}
		chunk* FindGroup( uint32 tag ) {
			chunk* cc = child();
			while(cc){
				chunk* pp = cc->child();
				if( pp && pp->tag == tag ){
					return pp;
				}
				cc = cc->next();
			}
			return 0;
		}

		void Reset() {
			memset(this,0,sizeof(*this));
			tag = ID('CHNK');
			SetHeaderSize( sizeof(*this) );
			SetAlignment( 4 );
		}
		void AddChunk( chunk* chk ) {
			if(child()){
				chunk* last = child();
				while(last->next()){
					last = last->next();
				}
				last->SetNext( chk );
			} else {
				SetChild( chk );
			}
		}

		void SaveAs( const char* outpath );
	};

	struct filechunk
	{
		com::chunk chunk;
		uint32 filesize;
		uint32 buildtimestamp;	//Cũrh^CX^v
		uint32 _reserved;

		void Reset() {
			memset(this,0,sizeof(*this));
			chunk.Reset();
			chunk.tag = com::chunk::ID('CHKB');
			chunk.SetHeaderSize( sizeof(*this) );
		}
	};

}}

#pragma pack( pop )
