//	shive's code 2008.08.20
//=============================================================================

#pragma once
#include "util.h"
#include "socket.h"

namespace shive { namespace com {

	//! fobO[eBeB
	class debug : statical<debug>
	{
#if !defined(TESTBUILD)
	public:
		struct ports {
			static int logger;
		};
#endif

	public:
		template<typename T=tick>
		class scopedtimer : noncopyable {
		public:
			explicit scopedtimer( const char* msg = "time: %d" ) : format( msg ) {
			}
			~scopedtimer() {
				debug::writeline( format.c_str(), T(tm.update()).get() );
			}
		private:
			const std::string format;
			timer tm;
		};

	public:
		//! g[X
		static void write( const char* fmt, va_list args )
		{
			char buf[ 2048 ];
			vsprintf_s( buf, fmt, args );
			outdebstr_(buf);
		}
		//! g[X
		static void write( const char* fmt, ... )
		{
			va_list args;
			va_start( args, fmt );
			write( fmt, args );
			va_end( args );
		}
		//! Psg[X
		static void writeline( const char* fmt, va_list args )
		{
			char buf[ 2048 ];
			vsprintf_s( buf, fmt, args );
			strcat_s(buf,"\n");
			outdebstr_(buf);
		}
		//! Psg[X
		static void writeline( const char* fmt, ... )
		{
			va_list args;
			va_start( args, fmt );
			writeline( fmt, args );
			va_end( args );
		}
		//! sg[X
		static void writeline()
		{
			outdebstr_("\n");
		}

	private:
		static void outdebstr_( const char* str )
		{
			::OutputDebugStringA(str);

#if !defined(TESTBUILD)
			static const int localhost = socket::hostipaddr("localhost");
			socket::sendto( localhost, ports::logger, str, (int)strlen(str) );
#endif
		}
	};

}}
