//	shive's code 2008.09.25
//=============================================================================

#include "stdafx.h"
#include "file.h"

namespace shive { namespace com {

	//! t@CŜǂݍ
	byte* file::read( const char* filepath, uint32* size )
	{
		uint32 _size = 0;
		if(!size){
			size = &_size;
		}
		const uint32 len = length(filepath);
		if( len > 0 ){
			FILE* fp = fopen( filepath, "rb" );
			if( fp ){
				byte* buf = new byte[len];//ACg␳
				(*size) = fread( buf, 1, len, fp );
				fclose(fp);
				return buf;
			}
		}
		(*size) = 0;
		return 0;
	}

	//! t@CփC[W
	bool file::write( const char* filepath, const byte* buffer, uint32 size )
	{
		std::string dir = path::directory(filepath);
		if(!directory::exists(dir.c_str())){
			directory::make(dir.c_str());
		}
		FILE* fp = fopen( filepath, "wb" );
		if( fp ){
			fwrite( buffer, 1, size, fp );
			fclose(fp);
			return true;
		}
		return false;
	}

	struct X
	{
		uint32 cc[ 0x100 ];
		X(){
			uint32 poly = 0xEDB88320;
			for( uint32 Li = 0; Li < (sizeof(cc)/sizeof(*cc)); ++Li ){
				uint32 u = Li;
				for( int Lj = 0; Lj < 8; ++Lj ){
					if( u & 0x1 ){
						u = (u >> 1) ^ poly;
					}
					else{
						u >>= 1;
					}
				}
				cc[ Li ] = u;
			}
		}
	};
	static uint32 getcrc( uint32 crc, byte cc )
	{
		static const X x;
		return (crc >> 8) ^ x.cc[cc ^ (crc & 0xFF)];
	}

	//! bqbvZ
	uint32 file::computecrc( const void* buffer, uint32 size )
	{
		uint32 crc = 0xFFFFFFFF;
		const byte* ptr = (byte*)buffer;
		const byte* const end = ptr + size;
		while( ptr != end ){
			crc = getcrc( crc, *ptr );
			++ptr;
		}
		return ~crc;
	}
	//! bqbvZ
	uint32 file::computecrc( const char* filepath )
	{
		uint32 size = 0;
		byte* buf = read( filepath, &size );
		uint32 crc = computecrc( buf, size );
		delete[] buf;
		return crc;
	}

}}
