//	shive's code 2008.09.25
//=============================================================================

#pragma once
#include "../types.h"
#include <stdio.h>
#include <direct.h>
#include <io.h>
#include <sys/stat.h>
#include <string>

namespace shive { namespace com {

	//! t@CpX
	struct path
	{
		//! t@Cigqtj
		static const char* filename( const char* filepath )
		{
			const char* p = filepath;
			const char* pp = strrchr( p, '\\' );
			p = pp? pp: p;
			pp = strrchr( p, '/' );
			p = pp? pp: p;
			return p + 1;
		}
		//! t@Cigqj
		static std::string filenamewithoutext( const char* filepath )
		{
			const char* p = filename( filepath );
			p = p? p: filepath;
			const char* pp = strrchr( p, '.' );
			return pp? std::string(p,0,pp-p): p;
		}
		//! sIhtgq
		static const char* extension( const char* filepath )
		{
			const char* p = filepath;
			const char* pp = strrchr( p, '.' );
			p = pp? pp: p;
			return p;
		}
		//! fBNgpXiŌ̃Zp[^݁j
		static std::string directory( const char* dirpath )
		{
			const char* p = dirpath;
			const char* pp = strrchr( p, '\\' );
			p = pp? pp: p;
			pp = strrchr( p, '/' );
			p = pp? pp: p;
			return std::string( dirpath, 0, (p - dirpath) + 1 );
		}
		//! tpX擾
		static std::string fullpath( const char* path )
		{
			char tmp[ MAX_PATH ];
			_fullpath(tmp,path,sizeof(tmp));
			return std::string(tmp);
		}
		//! pXڍ
		static std::string combine( const char* basedir, const char* path )
		{
			char tmp[ MAX_PATH ];
			char buf[ MAX_PATH ];
			_fullpath(tmp,basedir,sizeof(tmp));
			strcat(tmp,"\\");
			strcat(tmp,path);
			_fullpath(buf,tmp,sizeof(buf));
			return std::string(buf);
		}
		/*
		//! ΃pX
		static std::string relative( const char* basepath, const char* path )
		{
		}
		*/
	};

	//! t@C
	struct file
	{
		//! t@C̑݃`FbN
		static bool exists( const char* filepath )
		{
			_finddata_t data;
			intptr_t handle = _findfirst( filepath, &data );
			if( handle != -1 ){
				_findclose(handle);
				return (data.attrib & _A_SUBDIR)? false: true;//t@C
			}
			return false;
		}

		//! t@CTCY擾
		static uint32 length( const char* filepath )
		{
			FILE* fp = fopen( filepath, "rb" );
			if( fp ){
				return _filelength(_fileno(fp));
			}
			return 0;
		}

		//! t@C̃^CX^v
		static uint32 timestamp( const char* filepath )
		{
			FILE* fp = fopen( filepath, "rb" );
			if( fp ){
				struct stat status;
				const int err = fstat(_fileno(fp),&status);
				fclose(fp);
				if(!err){
					return (uint32)status.st_mtime;
				}
			}
			return 0;
		}

		//! t@CŜǂݍ
		static byte* read( const char* filepath, uint32* size = 0 );

		//! t@CփC[W
		static bool write( const char* filepath, const byte* buffer, uint32 size );

		//! t@C폜
		static bool remove( const char* filepath )
		{
			return ::DeleteFile(filepath)? true: false;
		}

		//! bqbvZ
		static uint32 computecrc( const void* buffer, uint32 size );
		//! bqbvZ
		static uint32 computecrc( const char* filepath );
	};

	//! fBNg
	struct directory
	{
		//! ݃`FbN
		static bool exists( const char* dirpath )
		{
			_finddata_t data;
			intptr_t handle = _findfirst( dirpath, &data );
			if( handle != -1 ){
				_findclose(handle);
				return (data.attrib & _A_SUBDIR)? true: false;//fBNg
			}
			return false;
		}
		//! 쐬
		static bool make( const char* dirpath )
		{
			return (_mkdir(dirpath) == 0);
		}
		//! ړ
		static bool set( const char* dirpath )
		{
			return (_chdir(dirpath) == 0);
		}
	};

	//! fBNgX^bN
	struct scopeddir
	{
		explicit scopeddir( const char* newpath = 0 ) {
			_getcwd(oldpath,sizeof(oldpath));
			if(newpath){
				_chdir(newpath);
			}
		}
		~scopeddir() {
			_chdir(oldpath);
		}
		char oldpath[ MAX_PATH ];
	};

}}
