//	shive's code 2008.08.25
//=============================================================================

#pragma once
#include "../types.h"

namespace shive { namespace com {

	class invoke : public countable {
	public:
		static objptr<invoke> gen( uint (*m)(uint), uint x );
		template<typename T>
		static objptr<invoke> gen( T* p, uint (T::*m)(uint), uint x );
	public:
		virtual ~invoke() {}
		virtual void operator () () = 0;
		virtual uint result() = 0;
	};

	template<typename T>
	class delegate : public invoke {
	public:
		typedef T* context;
		typedef uint (T::*method)( uint );
	public:
		explicit delegate( context _p, method _m, uint _x ) : p(_p), m(_m), x(_x) {
			incref(p);
			r = 0;
		}
		virtual ~delegate() {
			decref(p);
		}
		virtual void operator () () {
			r = (p->*m)(x);
		}
		virtual uint result() {
			return r;
		}
	private:
		const context p;
		const method m;
		const uint x;
		uint r;
	};
	template<>
	class delegate<void> : public invoke {
	public:
		typedef void context;
		typedef uint (*method)( uint );
	public:
		explicit delegate( method _m, uint _x ) : m(_m), x(_x) {
			r = 0;
		}
		virtual void operator () () {
			r = (*m)(x);
		}
		virtual uint result() {
			return r;
		}
	private:
		const method m;
		const uint x;
		uint r;
	};

	objptr<invoke> invoke::gen( uint (*m)(uint), uint x )
	{
		return objptr<invoke>( new delegate<void>(m,x) );
	}
	template<typename T>
	objptr<invoke> invoke::gen( T* p, uint (T::*m)(uint), uint x )
	{
		return objptr<invoke>( new delegate<T>(p,m,x) );
	}

}}
