//	shive's code 2008.08.19
//=============================================================================

#pragma once
#include "util.h"

namespace shive { namespace com {

	class tcpserver;
	
	//! \PbgʐMNX
	class socket : noncopyable
	{
	public:
		//! winsock̏
		static void initialize();
		//! winsock̏I
		static void terminate();
		//! zXgIPAhX擾
		static uint hostipaddr( const char* hostname );
		
	public:
		//! ^CAEg
		static const int NOTIMEOUT = 0x7FFFFFFF;
		//! ^CAEg
		static const int TIMEOUTED = -2;
		//! l
		static const int INVALID = -1;
		
	public:
		//! ȈUDPM
		static int sendto( uint ipaddr, int port, const void* buffer, int size );
		//! ȈUDPM
		static int recvfrom( int port, void* buffer, int maxsize, int timeout = NOTIMEOUT );

	public:
		socket() {
			sid_ = INVALID;
		}
		~socket() {
			disconnect();
		}
		
		bool connected() {
			return (sid_ < 0)? false: wait(0,false,false) >= 0;
		}
		
	public:
		//! T[o[\Pbg̏
		bool listen( int port, int backlog = 32 );
		//! NCAg̐ڑ҂
		bool accept( socket* dest, int timeout = NOTIMEOUT );
		//! ڑ
		bool connect( uint ipaddr, int port );
		//! 
		void disconnect();
		
		//! M\`FbN
		bool sendable( int timeout = NOTIMEOUT );
		//! M҂
		int send( const void* buffer, int size, int timeout = NOTIMEOUT );
		
		//! M\`FbN
		bool recvable( int timeout = NOTIMEOUT );
		//! M҂
		int recv( void* buffer, int maxsize, int timeout = NOTIMEOUT );
		
	private:
		int wait( int timeout, bool read, bool write );
		
		void swap( socket& rhs )
		{
			const int tmp = sid_;
			sid_ = rhs.sid_;
			rhs.sid_ = tmp;
		}
		
	private:
		int sid_;
		
		friend class tcpserver;
	};
	
	//! TCPXg[
	class tcpstream : noncopyable
	{
	public:
		//! ^CAEg
		static const int NOTIMEOUT = socket::NOTIMEOUT;
		//! ^CAEg
		static const int TIMEOUTED = socket::TIMEOUTED;
		//! l
		static const int INVALID = socket::INVALID;
		
	protected:
		tcpstream() {
		}
		~tcpstream() {
			socket_.disconnect();
		}
	public:
		bool connected() {
			return socket_.connected();
		}
		bool available() {
			return (connected() && socket_.recvable());
		}
		int write( const void* buffer, int size, int timeout = NOTIMEOUT );
		int read( void* buffer, int size, int timeout = NOTIMEOUT );
		
	protected:
		socket socket_;
	};
	
	//! TCPNCAg
	class tcpclient : public tcpstream
	{
	public:
		//! T[o[֐ڑ
		bool open( uint ipaddr, int port ) {
			socket_.disconnect();
			return socket_.connect( ipaddr, port );
		}
		//! T[o[֐ڑ
		bool open( const char* hostname, int port ) {
			return open( socket::hostipaddr(hostname), port );
		}
	};
	
	//! TCPT[o[
	class tcpserver : public tcpstream
	{
	public:
		//! NCAg̐ڑ҂
		bool open( int port ) {
			socket_.disconnect();
			if( socket_.listen( port, 1 ) ){
				socket tmp;
				if( !socket_.accept( &tmp, NOTIMEOUT ) ){
					socket_.disconnect();
					return false;
				}
				socket_.swap(tmp);
				return true;
			}
			return false;
		}
	};

}}
