//	shive's code 2008.10.02
//=============================================================================

#pragma once
#include "../types.h"

namespace shive { namespace com {

	namespace detail {

		static float s2f( uint16 bb )
		{
			union{
				uint32 bits;
				float value;
			};
			bits = (bb & 0x8000) << 16;
			int ee = (bb >> 10) & 0x1F;
			int mm = bb & 0x3FF;
			if(!ee){
				if(!mm){
					return value;//[
				}
				//񐳋K
				while(!(mm & 0x400)){
					mm <<= 1;
					ee -= 1;
				}
				++ee;
				mm &= ~0x400;
			}
			else if( ee == 0x1F ){
				bits |= (0xFF << 23);
				if(!mm){
					return value;//
				}
				//Nan
				bits |= mm << (23 - 10);
				return value;
			}
			ee += (0x7F - 0x0F);
			mm <<= (23 - 10);
			bits |= (ee << 23) | mm;
			return value;
		}

		static uint16 f2s( float value )
		{
			union{
				float _value;
				uint32 bits;
			};
			_value = value;
			uint16 bb = (uint16)(bits >> 16) & 0x8000;
			int ee = ((bits >> 23) & 0xFF) - (0x7F - 0x0F);
			int mm = bits & 0x7FFFFF;
			if( ee <= 0 ){
				if( ee < -10 ){
					return bb;
				}
				mm = (mm | 0x00800000) >> (1 - ee);
				if( mm & 0x00001000 ){
					mm += 0x00002000;
				}
				mm >>= (23 - 10);
				bb |= mm;
				return bb;
			}
			else if( ee == 0xFF - (0x7F - 0x0F) ){
				bb |= 0x1F << 10;
				if(!mm){
					return bb;
				}
				mm >>= (23 - 10);
				bb |= mm | (!mm);
				return bb;
			}
			if( mm & 0x00001000 ){
				mm += 0x00002000;
				if( mm & 0x00800000 ){
					mm = 0;
					ee += 1;
				}
			}
			if( ee > 0x1E ){
				//overflow
				bb |= (0x1F << 10);
				return bb;
			}
			mm >>= (23 - 10);
			bb |= (ee << 10) | mm;
			return bb;
		}

		struct half
		{
			uint16 b;

			half( float value ) {
				b = f2s(value);
			}
			explicit half( int bits ) {
				b = (uint16)bits;
			}
			half& operator = ( float value ) {
				b = f2s(value);
			}
			operator float () const {
				return s2f(b);
			}
		};

		struct int8N
		{
			int8 b;

			int8N( float value ) {
				b = (int8)(value * 127.0f);
			}
			explicit int8N( int bits ) {
				b = (int8)bits;
			}
			int8N& operator = ( float value ) {
				b = (int8)(value * 127.0f);
			}
			operator float () const {
				static const float coef = 1.0f / 127.0f;
				return (b * coef);
			}
		};
		struct uint8N
		{
			uint8 b;

			uint8N( float value ) {
				b = (uint8)(value * 255.0f);
			}
			explicit uint8N( uint bits ) {
				b = (uint8)bits;
			}
			uint8N& operator = ( float value ) {
				b = (uint8)(value * 255.0f);
			}
			operator float () const {
				static const float coef = 1.0f / 255.0f;
				return (b * coef);
			}
		};

		struct int16N
		{
			int16 b;

			int16N( float value ) {
				b = (int16)(value * 32767.0f);
			}
			explicit int16N( int bits ) {
				b = (int16)bits;
			}
			int16N& operator = ( float value ) {
				b = (int16)(value * 32767.0f);
			}
			operator float () const {
				static const float coef = 1.0f / 32767.0f;
				return (b * coef);
			}
		};
		struct uint16N
		{
			uint16 b;

			uint16N( float value ) {
				b = (uint16)(value * 65535.0f);
			}
			explicit uint16N( uint bits ) {
				b = (uint16)bits;
			}
			uint16N& operator = ( float value ) {
				b = (uint16)(value * 65535.0f);
			}
			operator float () const {
				static const float coef = 1.0f / 65535.0f;
				return (b * coef);
			}
		};

	}

	using detail::half;
	using detail::int8N;
	using detail::uint8N;
	using detail::int16N;
	using detail::uint16N;

}}
