//	shive's code 2008.09.15
//=============================================================================

#include "stdafx.h"
#include "Loader.h"
#include "Model.h"
#include "chk/Chunk.h"
#include "../scp/vmapi.h"
#include "../com/debug.h"
#include "../com/file.h"

#if defined(_DEBUG)
#define _(COND) (assert(COND))
#else
#define _(COND) (COND)
#endif

namespace shive { namespace fwk {

	extern IDirect3DDevice9* s_dev;

	static HRESULT hr = 0;

	class Loader::Impl
	{
	public:
		Impl()
		{
			memorypool_.reserve(32);
		}
		~Impl()
		{
			models_.clear();

			for( size_t Li = 0; Li < memorypool_.size(); ++Li ){
				delete[] memorypool_[ Li ];
			}
			memorypool_.clear();
		}

		std::vector< objptr<Model> > models_;

		std::vector<byte*> memorypool_;
	};

	Loader::Loader() : pimpl(new Impl())
	{
		scp::vmapi& vm = *scp::vmcontext::instance();

		vm.creg("loader",this)
			.function("LoadModel",&Loader::LoadModel)
			;
	}
	Loader::~Loader()
	{
	}

	namespace detail {

		class VS {
		public:
			explicit VS( scp::vmobj mesh ) {
				element.reserve(128);
				vertex.reserve(128);
				n = -1;
				
				//_錾̉
				{
					scp::vmobj vtel = mesh["VTEL"];

					int stride = 0;
					ve.reserve(vtel.getsize());
					src.reserve(vtel.getsize());
					for( scp::vmiter vei = vtel; !vei.isend(); ++vei ){
						const char* const veusage = (*vei)[0];
						const char* const veformat = (*vei)[1];
						D3DVERTEXELEMENT9 decl;
						memset(&decl,0,sizeof(decl));
						decl.Stream = 0;
						decl.Offset = (WORD)stride;
						decl.Type = (BYTE)_decltype(veformat);
						decl.Method = D3DDECLMETHOD_DEFAULT;
						decl.Usage = (BYTE)_usage(veusage);
						decl.UsageIndex = (BYTE)_usageindex(veusage);
						ve.push_back(decl);
						src.push_back(mesh[veusage]);
						stride += _stride(_decltype(veformat));
					}
					const D3DVERTEXELEMENT9 end = D3DDECL_END();
					ve.push_back(end);
					this->stride_ = stride;
				}
			}
			~VS() {
				for( size_t Li = 0; Li < element.size(); ++Li ){
					delete[] element[Li];
				}
				element.clear();
				for( size_t Li = 0; Li < vertex.size(); ++Li ){
					delete[] vertex[Li];
				}
				vertex.clear();
			}
			int add( scp::vmobj e ) {
				int* const v = copy(e);
				for(size_t Li = 0; Li < element.size(); ++Li ){
					if(compare(v,element[Li],n)){
						delete[] v;
						return Li;
					}
				}
				element.push_back(v);

				byte* vb = new byte[this->stride_];
				vertex.push_back(vb);
				//POS
				((float*)vb)[0] = (float)src[0][v[0]][0];
				((float*)vb)[1] = (float)src[0][v[0]][1];
				((float*)vb)[2] = (float)src[0][v[0]][2];
				vb+=12;
				//NOR
				((float*)vb)[0] = (float)src[1][v[1]][0];
				((float*)vb)[1] = (float)src[1][v[1]][1];
				((float*)vb)[2] = (float)src[1][v[1]][2];
				vb+=12;
				//COL
				((byte*)vb)[0] = (byte)(int)src[2][v[2]][0];
				((byte*)vb)[1] = (byte)(int)src[2][v[2]][1];
				((byte*)vb)[2] = (byte)(int)src[2][v[2]][2];
				((byte*)vb)[3] = (byte)(int)src[2][v[2]][3];
				vb+=4;
				//UV0
				((float*)vb)[0] = (float)src[3][v[3]][0];
				((float*)vb)[1] = (float)src[3][v[3]][1];
				vb+=8;

				return element.size() - 1;
			}
			int* copy( scp::vmobj& e ) {
				const int s = e.getsize();
				if( n < 0 ){
					n = s;
				} else {
					_(n == s);
				}
				int* const v = new int[s];
				for( int Li = 0; Li < s; ++Li ){
					v[Li] = (int)e[Li];
				}
				return v;
			}
			bool compare( int* lhs, int* rhs, int s ) {
				for( int Li = 0; Li < s; ++Li ){
					if( lhs[Li] != rhs[Li] ){
						return false;
					}
				}
				return true;
			}
			int stride() const {
				return this->stride_;
			}
			int vertexcount() const {
				return vertex.size();
			}
			byte* createbuffer() {
				const size_t size = this->stride_ * vertex.size();
				com::chunk* chk = (com::chunk*)(new byte[sizeof(com::chunk)+size]);
				chk->Reset();
				chk->tag = com::chunk::ID('VTXB');
				chk->SetDataSize( size );
				byte* ptr = (byte*)(chk + 1);
				for( size_t Li = 0; Li < vertex.size(); ++Li ){
					memcpy(ptr,vertex[Li],stride_);
					ptr += stride_;
				}
				return (byte*)chk;
			}
			byte* createdeclaration() {
				const size_t len = sizeof(D3DVERTEXELEMENT9) * ve.size();
				com::chunk* chk = (com::chunk*)(new byte[sizeof(com::chunk)+len]);
				chk->Reset();
				chk->tag = com::chunk::ID('VTEL');
				chk->SetDataSize( len );
				memcpy(chk->data(),&ve[0],len);
				return (byte*)chk;
			}
		private:
			static D3DDECLTYPE _decltype( const char* str )
			{
				if(!_stricmp(str,"F1")||!_stricmp(str,"F")){
					return D3DDECLTYPE_FLOAT1;
				}
				if(!_stricmp(str,"F2")){
					return D3DDECLTYPE_FLOAT2;
				}
				if(!_stricmp(str,"F3")){
					return D3DDECLTYPE_FLOAT3;
				}
				if(!_stricmp(str,"F4")){
					return D3DDECLTYPE_FLOAT4;
				}
				if(!_stricmp(str,"C")){
					return D3DDECLTYPE_D3DCOLOR;
				}
				if(!_stricmp(str,"B4N")){
					return D3DDECLTYPE_UBYTE4N;
				}
				if(!_stricmp(str,"S2N")){
					return D3DDECLTYPE_SHORT2N;
				}
				if(!_stricmp(str,"S4N")){
					return D3DDECLTYPE_SHORT4N;
				}
				if(!_stricmp(str,"US2N")){
					return D3DDECLTYPE_USHORT2N;
				}
				if(!_stricmp(str,"US4N")){
					return D3DDECLTYPE_USHORT4N;
				}
				if(!_stricmp(str,"UDEC3")){
					return D3DDECLTYPE_UDEC3;
				}
				if(!_stricmp(str,"DEC3N")){
					return D3DDECLTYPE_DEC3N;
				}
				if(!_stricmp(str,"H2")){
					return D3DDECLTYPE_FLOAT16_2;
				}
				if(!_stricmp(str,"H4")){
					return D3DDECLTYPE_FLOAT16_4;
				}
				_(0);
				return D3DDECLTYPE_UNUSED;
			}
			static int _stride( D3DDECLTYPE decltype )
			{
				switch(decltype){
				case D3DDECLTYPE_FLOAT1:
					return sizeof(float)*1;
				case D3DDECLTYPE_FLOAT2:
					return sizeof(float)*2;
				case D3DDECLTYPE_FLOAT3:
					return sizeof(float)*3;
				case D3DDECLTYPE_FLOAT4:
					return sizeof(float)*4;
				case D3DDECLTYPE_D3DCOLOR:
					return sizeof(byte)*4;
				case D3DDECLTYPE_UBYTE4N:
					return sizeof(byte)*4;
				case D3DDECLTYPE_SHORT2N:
					return sizeof(short)*2;
				case D3DDECLTYPE_SHORT4N:
					return sizeof(short)*4;
				case D3DDECLTYPE_USHORT2N:
					return sizeof(short)*2;
				case D3DDECLTYPE_USHORT4N:
					return sizeof(short)*4;
				case D3DDECLTYPE_UDEC3:
					return sizeof(uint);
				case D3DDECLTYPE_DEC3N:
					return sizeof(uint);
				case D3DDECLTYPE_FLOAT16_2:
					return sizeof(short)*2;
				case D3DDECLTYPE_FLOAT16_4:
					return sizeof(short)*4;
				default:
					return 0;
				}
			}
			static D3DDECLUSAGE _usage( const char* str )
			{
				if(!_stricmp(str,"POS")){
					return D3DDECLUSAGE_POSITION;
				}
				if(!_stricmp(str,"NOR")){
					return D3DDECLUSAGE_NORMAL;
				}
				if(!_stricmp(str,"COL")){
					return D3DDECLUSAGE_COLOR;
				}
				if(!_strnicmp(str,"UV",2)){
					return D3DDECLUSAGE_TEXCOORD;
				}
				/*
				if(!_stricmp(str,"BLENDWEIGHT")){
					return D3DDECLUSAGE_BLENDWEIGHT;
				}
				if(!_stricmp(str,"BLENDINDICES")){
					return D3DDECLUSAGE_BLENDINDICES;
				}
				if(!_stricmp(str,"PSIZE")){
					return D3DDECLUSAGE_PSIZE;
				}
				if(!_stricmp(str,"TANGENT")){
					return D3DDECLUSAGE_TANGENT;
				}
				if(!_stricmp(str,"BINORMAL")){
					return D3DDECLUSAGE_BINORMAL;
				}
				if(!_stricmp(str,"TESSFACTOR")){
					return D3DDECLUSAGE_TESSFACTOR;
				}
				if(!_stricmp(str,"POSITIONT")){
					return D3DDECLUSAGE_POSITIONT;
				}
				if(!_stricmp(str,"FOG")){
					return D3DDECLUSAGE_FOG;
				}
				if(!_stricmp(str,"DEPTH")){
					return D3DDECLUSAGE_DEPTH;
				}
				if(!_stricmp(str,"SAMPLE")){
					return D3DDECLUSAGE_SAMPLE;
				}
				*/
				_(0);
				return D3DDECLUSAGE_POSITION;
			}
			static uint _usageindex( const char* str )
			{
				if(!_strnicmp(str,"UV",2)){
					return str[2]-'0';
				}
				return 0;
			}
		private:
			std::vector<scp::vmobj> src;
			std::vector<D3DVERTEXELEMENT9> ve;
			std::vector<byte*> vertex;
			std::vector<int*> element;
			int stride_;
			int n;
		};

		class IS {
		public:
			IS() {
			}
			~IS() {
			}
			void add( int i0, int i1, int i2 ) {
				x.push_back(static_cast<byte>(i0));
				x.push_back(static_cast<byte>(i1));
				x.push_back(static_cast<byte>(i2));
			}
			byte* createbuffer() {
				const size_t size = sizeof(uint16) * x.size();
				com::chunk* chk = (com::chunk*)(new byte[sizeof(com::chunk)+size]);
				chk->Reset();
				chk->tag = com::chunk::ID('IDXB');
				chk->SetDataSize( size );
				byte* ptr = (byte*)(chk + 1);
				memcpy(ptr,&x[0],size);
				return (byte*)chk;
			}
			int trianglecount() const {
				return x.size() / 3;
			}
		private:
			std::vector<uint16> x;
		};

	}

	struct ShaderParameterPage {
		int index;
		chk::ShaderParameter* parameter;
	};
	typedef std::vector<ShaderParameterPage> ShaderParameterPageContainer;
	typedef std::map<std::string,ShaderParameterPage*> ShaderParameterPageDictionary;
	static inline char* mystrdup( const char* str )
	{
		char* pp = new char[strlen(str)+1];
		strcpy(pp,str);
		return pp;
	}
	static bool createmodelcache( const char* outpath, const char* srcpath )
	{
		//\[Xt@C̏擾
		const uint32 source_filesize = com::file::length(srcpath);
		const uint32 source_timestamp = com::file::timestamp(srcpath);
		const uint32 source_crc = com::file::computecrc(srcpath);
		
#if 0
		//t@C̍XV`FbN
		if( com::file::exists(outpath) ){
			byte* cache = com::file::read(outpath);
			chk::Model* const model = ((chk::File*)cache)->model();
			bool check = true;
			check &= (model->source.filesize == source_filesize);
			check &= (model->source.timestamp == source_timestamp);
			check &= (model->source.crc == source_crc);
			delete[] cache;
			if( check ){
				return true;//LbVt@Cg
			}
		}
#endif

		scp::vmthread vm(*scp::vmcontext::instance(),1024);

		//t@Cǂݍ
		if(!vm.dofile(srcpath,true)){
			return false;
		}
		scp::vmobj src = vm.pop();

		std::vector<byte*> mempool;

		chk::Model chkmodel;
		chkmodel.Reset();
		chkmodel.source.filesize = source_filesize;
		chkmodel.source.timestamp = source_timestamp;
		chkmodel.source.crc = source_crc;
		
		com::chunk chkmeshes;
		chkmeshes.Reset();
		chkmodel.chunk.AddChunk(&chkmeshes);
		com::chunk chkmaterials;
		chkmaterials.Reset();
		chkmodel.chunk.AddChunk(&chkmaterials);
		com::chunk chktags;
		chktags.Reset();
		chkmodel.chunk.AddChunk(&chktags);

		//}eAf[^
		std::map<std::string,uint16> materiallinker;
		{
			com::scopeddir sd(com::path::directory(srcpath).c_str());

			uint16 index = 0;
			for( scp::vmiter mat = src["OBJ"]["MAT"]; !mat.isend(); ++mat ){
				const char* const materialname = mat.key();
				const char* const shadercode = (*mat)["CODE"];

				chk::Material* const chkmat = (chk::Material*)(new byte[sizeof(chk::Material)]);
				mempool.push_back((byte*)chkmat);
				chkmaterials.AddChunk(&chkmat->chunk);
				chkmat->Reset();

				//RST
				{
					scp::vmobj renderstate = (*mat)["RST"];

					//cullmode
					const char* const cullmode = renderstate["cullmode"];
					if( *cullmode ){
						if(!_stricmp(cullmode,"none")){
							chkmat->renderstate.cullmode = D3DCULL_NONE;
						} else
						if(!_stricmp(cullmode,"cw")){
							chkmat->renderstate.cullmode = D3DCULL_CW;
						} else
						if(!_stricmp(cullmode,"ccw")){
							chkmat->renderstate.cullmode = D3DCULL_CCW;
						}
					}
				}

				//_VF[_O[v
				com::chunk* const vertexshaders = (com::chunk*)(new byte[sizeof(com::chunk)]);
				mempool.push_back((byte*)vertexshaders);
				vertexshaders->Reset();
				chkmat->chunk.AddChunk(vertexshaders);

				//sNZVF[_O[v
				com::chunk* const pixelshaders = (com::chunk*)(new byte[sizeof(com::chunk)]);
				mempool.push_back((byte*)pixelshaders);
				pixelshaders->Reset();
				chkmat->chunk.AddChunk(pixelshaders);

				com::chunk* const shaders[] = {
					vertexshaders,
					pixelshaders,
				};

				//p[^O[v
				com::chunk* const params = (com::chunk*)(new byte[sizeof(com::chunk)]);
				mempool.push_back((byte*)params);
				params->Reset();
				chkmat->chunk.AddChunk(params);

				ShaderParameterPageContainer table;
				ShaderParameterPageDictionary dict;

				//_VF[_AsNZVF[_
				int regcnt = 0;
				for( scp::vmiter itcaps = (*mat)["CAPS"]; !itcaps.isend(); ++itcaps ){

					//caps
					chk::ShaderCaps caps;
					memset(&caps,0,sizeof(caps));
					caps.traits.diffusemap = (int)(*itcaps)["trait"]["diffusemap"];
					caps.vertex.dir   = (int)(*itcaps)["vertex"]["dir"];
					caps.vertex.point = (int)(*itcaps)["vertex"]["point"];
					caps.vertex.spot  = (int)(*itcaps)["vertex"]["spot"];
					caps.pixel.dir    = (int)(*itcaps)["pixel"]["dir"];
					caps.pixel.point  = (int)(*itcaps)["pixel"]["point"];
					caps.pixel.spot   = (int)(*itcaps)["pixel"]["spot"];

					//caps -> defines
					std::vector<char*> macros;
					{
						char buf[ 32 ];

						//_CeBO
						if( caps.vertex.dir > 0 ){
							sprintf(buf,"%d",caps.vertex.dir);
							macros.push_back(mystrdup("CAPS_VERTEX_DIR"));
							macros.push_back(mystrdup(buf));
						}
						if( caps.vertex.point > 0 ){
							sprintf(buf,"%d",caps.vertex.point);
							macros.push_back(mystrdup("CAPS_VERTEX_POINT"));
							macros.push_back(mystrdup(buf));
						}
						if( caps.vertex.spot > 0 ){
							sprintf(buf,"%d",caps.vertex.spot);
							macros.push_back(mystrdup("CAPS_VERTEX_SPOT"));
							macros.push_back(mystrdup(buf));
						}

						//sNZCeBO
						if( caps.pixel.dir > 0 ){
							sprintf(buf,"%d",caps.pixel.dir);
							macros.push_back(mystrdup("CAPS_PIXEL_DIR"));
							macros.push_back(mystrdup(buf));
						}
						if( caps.pixel.point > 0 ){
							sprintf(buf,"%d",caps.pixel.point);
							macros.push_back(mystrdup("CAPS_PIXEL_POINT"));
							macros.push_back(mystrdup(buf));
						}
						if( caps.pixel.spot > 0 ){
							sprintf(buf,"%d",caps.pixel.spot);
							macros.push_back(mystrdup("CAPS_PIXEL_SPOT"));
							macros.push_back(mystrdup(buf));
						}
					}
					macros.push_back(0);
					macros.push_back(0);

					for( int Li = 0; Li < 2; ++Li ){
						comptr<ID3DXBuffer> shader;
						comptr<ID3DXConstantTable> constant;
						comptr<ID3DXBuffer> err;

						//compile
						hr = D3DXCompileShaderFromFile(
							shadercode,
							(const D3DXMACRO*)&macros[0],
							0,
							!Li? "vsmain": "psmain",
							!Li? "vs_3_0": "ps_3_0",
							0,
							&shader,
							&err,
							&constant );
						if( hr ){
							com::debug::writeline("}eA'%s'RpCł܂B",materialname);
							break;
						}
						D3DXCONSTANTTABLE_DESC ctd;
						hr = constant->GetDesc(&ctd);

						const uint32 headersize = sizeof(chk::ShaderCode)+sizeof(chk::ShaderRegister)*ctd.Constants;
						const uint32 codesize = shader->GetBufferSize();
						chk::ShaderCode* const chkcode = (chk::ShaderCode*)(new byte[headersize+codesize]);
						mempool.push_back((byte*)chkcode);
						shaders[Li]->AddChunk(&chkcode->chunk);
						chkcode->Reset(!Li);
						chkcode->chunk.SetHeaderSize(headersize);
						chkcode->chunk.SetDataSize(codesize);
						chkcode->caps = caps;
						memcpy(chkcode->chunk.data(),shader->GetBufferPointer(),codesize);

						//parameter
						for( uint Lj = 0; Lj < ctd.Constants; ++Lj ){
							D3DXCONSTANT_DESC desc;
							constant->GetConstantDesc(constant->GetConstant(0,Lj),&desc,0);
							if( desc.Class != D3DXPC_SCALAR &&
								desc.Class != D3DXPC_VECTOR &&
								desc.Class != D3DXPC_MATRIX_ROWS &&
								desc.Class != D3DXPC_MATRIX_COLUMNS )
							{
								continue;
							}
							if( desc.Type != D3DXPT_BOOL &&
								desc.Type != D3DXPT_INT &&
								desc.Type != D3DXPT_FLOAT &&
								desc.Type != D3DXPT_TEXTURE &&
								desc.Type != D3DXPT_TEXTURE1D &&
								desc.Type != D3DXPT_TEXTURE2D &&
								desc.Type != D3DXPT_TEXTURE3D &&
								desc.Type != D3DXPT_TEXTURECUBE &&
								desc.Type != D3DXPT_SAMPLER &&
								desc.Type != D3DXPT_SAMPLER1D &&
								desc.Type != D3DXPT_SAMPLER2D &&
								desc.Type != D3DXPT_SAMPLER3D &&
								desc.Type != D3DXPT_SAMPLERCUBE )
							{
								continue;
							}

							ShaderParameterPageDictionary::iterator iter = dict.find(desc.Name);
							chk::ShaderParameter* chksprm = 0;
							if( iter == dict.end() ){
								const uint32 namelen = strlen(desc.Name);
								const uint32 structsize = sizeof(chk::ShaderParameter);
								const uint32 headersize = (structsize + namelen + 4 - 1) & ~(4 - 1);
								const uint32 len = headersize + desc.Bytes;
								chksprm = (chk::ShaderParameter*)(new byte[len]);
								memset(chksprm,0,len);
								mempool.push_back((byte*)chksprm);
								params->AddChunk(&chksprm->chunk);
								chksprm->Reset();
								chksprm->chunk.SetHeaderSize(headersize);
								strcpy(chksprm->name,desc.Name);
								chksprm->chunk.SetDataSize(desc.Bytes);
								chksprm->type = chk::ShaderParameter::kAsFloat;
								chksprm->size = (uint8)desc.RegisterCount;
								if(desc.DefaultValue){
									memcpy(chksprm->chunk.data(),desc.DefaultValue,desc.Bytes);
								}

								//o^
								ShaderParameterPage page;
								page.index = dict.size();
								page.parameter = chksprm;
								table.push_back(page);
								dict[desc.Name] = &table.back();
								iter = dict.find(desc.Name);
							}
							else{
								ShaderParameterPage* const page = (*iter).second;
								chksprm = page->parameter;
								if( chksprm->size != desc.RegisterCount ){
									com::debug::writeline("VF[_p[^̃TCYႤ");
								}
							}
							chkcode->connect[regcnt].var = (uint16)(*iter).second->index;
							chkcode->connect[regcnt].reg = (uint16)desc.RegisterIndex;
							++regcnt;
						}
					}

					for( size_t Li = 0; Li < macros.size(); ++Li ){
						delete[] macros[ Li ];
					}
				}
				materiallinker[materialname] = (uint16)index++;
			}
		}

		//bVf[^
		{
			uint16 index = 0;
			for( scp::vmiter mesh = src["OBJ"]["MESH"]; !mesh.isend(); ++mesh ){
				for( scp::vmiter m = (*mesh)["MAT"]; !m.isend(); ++m ){
					const char* const materialname = m.key();
					if(materiallinker.find(materialname)==materiallinker.end()){
						com::debug::writeline("|SɃATCꂽ}eA'%s'܂B",materialname);
						break;
					}
					detail::VS vs(*mesh);
					detail::IS is;
					scp::vmobj poly = (*mesh)["POLY"];
					for( scp::vmiter p = (*m); !p.isend(); ++p ){
						scp::vmiter v = poly[(int)(*p)];
						const int i0 = vs.add(*v);++v;
						int i1 = vs.add(*v);++v;
						while(!v.isend()){
							const int i2 = vs.add(*v);++v;
							is.add(i0,i1,i2);
							i1 = i2;
						}
					}

					chk::Mesh* const chkmesh = (chk::Mesh*)(new byte[sizeof(chk::Mesh)]);
					mempool.push_back((byte*)chkmesh);
					chkmeshes.AddChunk(&chkmesh->chunk);
					chkmesh->Reset();
					chkmesh->vertexcount = vs.vertexcount();
					chkmesh->stride = vs.stride();
					chkmesh->triangle = is.trianglecount();

					//_錾
					byte* const vertexdeclaration = vs.createdeclaration();
					mempool.push_back(vertexdeclaration);
					chkmesh->chunk.AddChunk((com::chunk*)vertexdeclaration);

					//_obt@
					byte* const vertexbuffer = vs.createbuffer();
					mempool.push_back(vertexbuffer);
					chkmesh->chunk.AddChunk((com::chunk*)vertexbuffer);

					//CfNXobt@
					byte* const indexbuffer = is.createbuffer();
					mempool.push_back(indexbuffer);
					chkmesh->chunk.AddChunk((com::chunk*)indexbuffer);

					//^O
					chk::Tag* const chktag = (chk::Tag*)(new byte[sizeof(chk::Tag)]);
					mempool.push_back((byte*)chktag);
					chktags.AddChunk(&chktag->chunk);
					chktag->Reset();
					chktag->material = materiallinker[materialname];
					chktag->mesh = index++;
				}
			}
		}

		//LbVt@CƂĕۑ
		chkmodel.chunk.SaveAs(outpath);

		//e|
		for( size_t Li = 0; Li < mempool.size(); ++Li ){
			delete[] mempool[ Li ];
		}
		mempool.clear();

		return true;
	}

	Model* Loader::LoadModel( const char* path )
	{
		//LbVt@CpX𐶐
		char cachepath[ MAX_PATH ];
		{
			std::string tmp = com::path::directory(path);
			tmp += ".cache\\";
			tmp += com::path::filename(path);
			tmp += ".chb";
			_fullpath(cachepath,tmp.c_str(),sizeof(cachepath));
		}

		//LbV݂Ȃ΍
		if( !createmodelcache(cachepath,path) ){
			return 0;
		}

		//LbVt@Cǂݎăf쐬
		byte* const buf = com::file::read(cachepath);
		pimpl->memorypool_.push_back(buf);
		com::filechunk* const chkfile = (com::filechunk*)buf;
		chk::Model* const chkmodel = (chk::Model*)chkfile->chunk.Find(com::chunk::ID('MDL\0'));
		objptr<Model> model( new Model(chkmodel) );
		pimpl->models_.push_back(model);
		return model.get();
	}

}}
