//	shive's code 2008.08.18
//=============================================================================

#include "stdafx.h"
#include "Model.h"
#include "chk/Chunk.h"
#include "../scp/vmapi.h"

#define CODESTR(CODE) #CODE

#pragma warning(disable:4100)	//͊֐̖{̕ 1 xQƂ܂B

namespace shive { namespace fwk {

	using com::vector;
	using com::matrix;
	using com::aabb;
	using com::degree;
	using com::radian;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	IDirect3DDevice9* s_dev = 0;
	static comptr<ID3DXFont> s_font;

	Graphics::Graphics( IDirect3DDevice9* device )
	{
		assert(!s_dev);

		s_dev = device;

		HRESULT hr = 0;
		hr = ::D3DXCreateFont(
			s_dev,
			-13,
			0,
			FW_BOLD,
			0,
			false,
			SHIFTJIS_CHARSET,
			OUT_DEFAULT_PRECIS,
			DEFAULT_QUALITY,
			DEFAULT_PITCH,
			"Terminal",//"lr@SVbN",
			&s_font );
		assert(s_font);
	}
	Graphics::~Graphics()
	{
		s_font.reset();
		s_dev = 0;
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	void Gadget::DrawText( uint x, uint y, const char* str )
	{
		assert(s_font);
		HRESULT hr = 0;
		RECT rec2 = { x + 1, y + 1, x + 1, y + 1 };
		hr = s_font->DrawText(0,str,-1,&rec2,DT_LEFT|DT_TOP|DT_NOCLIP,D3DCOLOR_XRGB(0,0,0));
		RECT rec = { x, y, x, y };
		hr = s_font->DrawText(0,str,-1,&rec,DT_LEFT|DT_TOP|DT_NOCLIP,D3DCOLOR_XRGB(255,255,255));
	}
	void Gadget::DrawLine( const vector& va, const vector& vb, uint color )
	{
		struct {
			float pos[ 3 ];
			uint col;
		} vertex[ 2 ] = {
			{ va[0], va[1], va[2], color },
			{ vb[0], vb[1], vb[2], color },
		};
		HRESULT hr = 0;
		hr = s_dev->SetFVF( D3DFVF_XYZ | D3DFVF_DIFFUSE );
		hr = s_dev->DrawPrimitiveUP( D3DPT_LINELIST, sizeof(vertex)/sizeof(vertex[0]), vertex, sizeof(vertex[0]) );
	}
	static inline void DrawBoxSolid( const aabb& box, const matrix& mat, uint color )
	{
		const float p =  1.0f;
		const float m = -1.0f;
		struct vertex {
			float p[3];
			float n[3];
			uint c;
			vertex(const vector& x,const vector& y,uint z) {
				p[0] = x[0]; p[1] = x[1]; p[2] = x[2];
				n[0] = y[0]; n[1] = y[1]; n[2] = y[2];
				//c = z;
				c = D3DCOLOR_XRGB(
					(n[0]==0.0f)?128:(n[0]>0.0f)?255:0,
					(n[1]==0.0f)?128:(n[1]>0.0f)?255:0,
					(n[2]==0.0f)?128:(n[2]>0.0f)?255:0 );
			}
		};
		const matrix bmat = mat * matrix::translation(box.center()) * matrix::scaling(box.halfextent());
		const vector pnt[ 8 ] = {
			bmat.affineTransform(vector(m,m,m)),
			bmat.affineTransform(vector(m,m,p)),
			bmat.affineTransform(vector(m,p,m)),
			bmat.affineTransform(vector(m,p,p)),
			bmat.affineTransform(vector(p,m,m)),
			bmat.affineTransform(vector(p,m,p)),
			bmat.affineTransform(vector(p,p,m)),
			bmat.affineTransform(vector(p,p,p)),
		};
		const vector nor[ 6 ] = {
			vector::xunit(),-vector::xunit(),
			vector::yunit(),-vector::yunit(),
			vector::zunit(),-vector::zunit(),
		};
		const vertex vertices[] = {
			vertex(pnt[0],nor[1],color),vertex(pnt[1],nor[1],color),vertex(pnt[2],nor[1],color),vertex(pnt[3],nor[1],color),
			vertex(pnt[4],nor[0],color),vertex(pnt[5],nor[0],color),vertex(pnt[6],nor[0],color),vertex(pnt[7],nor[0],color),
			vertex(pnt[0],nor[3],color),vertex(pnt[1],nor[3],color),vertex(pnt[4],nor[3],color),vertex(pnt[5],nor[3],color),
			vertex(pnt[2],nor[2],color),vertex(pnt[3],nor[2],color),vertex(pnt[6],nor[2],color),vertex(pnt[7],nor[2],color),
			vertex(pnt[0],nor[5],color),vertex(pnt[4],nor[5],color),vertex(pnt[2],nor[5],color),vertex(pnt[6],nor[5],color),
			vertex(pnt[1],nor[4],color),vertex(pnt[5],nor[4],color),vertex(pnt[3],nor[4],color),vertex(pnt[7],nor[4],color),
		};
		const ushort indices[][3] = {
			{0,1,2},{1,2,3},
			{4,5,6},{5,6,7},
			{8,9,10},{9,10,11},
			{12,13,14},{13,14,15},
			{16,17,18},{17,18,19},
			{20,21,22},{21,22,23},
		};
		HRESULT hr = 0;
		hr = s_dev->SetFVF( D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_DIFFUSE );
		hr = s_dev->DrawIndexedPrimitiveUP( D3DPT_TRIANGLELIST, 0, sizeof(vertices)/sizeof(vertices[0]), sizeof(indices)/sizeof(indices[0]), indices, D3DFMT_INDEX16, vertices, sizeof(vertices[0]) );
	}
	static inline void DrawBoxWire( const aabb& box, const matrix& mat, uint color )
	{
		const float p =  1.0f;
		const float m = -1.0f;
		struct vertex {
			float p[3];
			uint c;
		};
		const matrix bmat = mat * matrix::translation(box.center()) * matrix::scaling(box.halfextent());
		const vector pnt[ 8 ] = {
			bmat.affineTransform(vector(m,m,m)),
			bmat.affineTransform(vector(m,m,p)),
			bmat.affineTransform(vector(m,p,m)),
			bmat.affineTransform(vector(m,p,p)),
			bmat.affineTransform(vector(p,m,m)),
			bmat.affineTransform(vector(p,m,p)),
			bmat.affineTransform(vector(p,p,m)),
			bmat.affineTransform(vector(p,p,p)),
		};
		const vertex vertices[ 8 ] = {
			{pnt[0][0],pnt[0][1],pnt[0][2],color},
			{pnt[1][0],pnt[1][1],pnt[1][2],color},
			{pnt[2][0],pnt[2][1],pnt[2][2],color},
			{pnt[3][0],pnt[3][1],pnt[3][2],color},
			{pnt[4][0],pnt[4][1],pnt[4][2],color},
			{pnt[5][0],pnt[5][1],pnt[5][2],color},
			{pnt[6][0],pnt[6][1],pnt[6][2],color},
			{pnt[7][0],pnt[7][1],pnt[7][2],color},
		};
		const ushort indices[][2] = {
			{0,1},{1,3},{3,2},{2,0},
			{4,5},{5,7},{7,6},{6,4},
			{0,4},{1,5},{3,7},{2,6},
		};
		HRESULT hr = 0;
		hr = s_dev->SetFVF( D3DFVF_XYZ | D3DFVF_DIFFUSE );
		hr = s_dev->DrawIndexedPrimitiveUP( D3DPT_LINELIST, 0, sizeof(vertices)/sizeof(vertices[0]), sizeof(indices)/sizeof(indices[0]), indices, D3DFMT_INDEX16, vertices, sizeof(vertices[0]) );
	}
	void Gadget::DrawBox( const aabb& box, const matrix& mat, uint color, bool solid )
	{
		if( solid ){
			DrawBoxSolid( box, mat, color );
		}
		else{
			DrawBoxWire( box, mat, color );
		}
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	Mesh::Mesh( chk::Mesh* chkmesh )
	{
		HRESULT hr = 0;
		
		this->boundary_ = aabb::identity();

		//_錾
		{
			D3DVERTEXELEMENT9* ve = (D3DVERTEXELEMENT9*)chkmesh->vertexelements();
			hr = s_dev->CreateVertexDeclaration(ve,&this->decl_);
		}

		//_obt@
		{
			void* data = chkmesh->vertexbuffer();
			const int size = chkmesh->stride * chkmesh->vertexcount;
			hr = s_dev->CreateVertexBuffer(
				size,
				D3DUSAGE_WRITEONLY,
				0,
				D3DPOOL_DEFAULT,
				&this->vtxbuf_,
				0 );
			byte* buf = 0;
			hr = this->vtxbuf_->Lock(0,size,(void**)&buf,0);
			memcpy(buf,data,size);
			hr = this->vtxbuf_->Unlock();
		}

		//CfNXobt@
		{
			void* data = chkmesh->indexbuffer();
			const int size = sizeof(uint16) * chkmesh->triangle * 3;
			hr = s_dev->CreateIndexBuffer(
				size,
				D3DUSAGE_WRITEONLY,
				D3DFMT_INDEX16,
				D3DPOOL_DEFAULT,
				&this->idxbuf_,
				0 );
			byte* buf = 0;
			hr = this->idxbuf_->Lock(0,size,(void**)&buf,0);
			memcpy(buf,data,size);
			hr = this->idxbuf_->Unlock();
		}

		//p[^
		this->stride_ = chkmesh->stride;
		this->vtxcnt_ = chkmesh->vertexcount;
		this->tricnt_ = chkmesh->triangle;
	}
	Mesh::~Mesh()
	{
	}

	void Mesh::Draw()
	{
		HRESULT hr = 0;
		hr = s_dev->SetVertexDeclaration(this->decl_);
		hr = s_dev->SetStreamSource(0,this->vtxbuf_,0,this->stride_);
		hr = s_dev->SetIndices(this->idxbuf_);
		hr = s_dev->DrawIndexedPrimitive(D3DPT_TRIANGLELIST,0,0,this->vtxcnt_,0,this->tricnt_);
		//Gadget::DrawBox( this->boundary_, matrix::identity(), D3DCOLOR_XRGB(0,255,255), true );
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	template<typename T>
	class Shader
	{
	private:
		static T* _create( const DWORD* codebin );
		static void _apply( T* );

	public:
		explicit Shader( chk::ShaderCode* shader )
		{
			pshader_ = _create((DWORD*)shader->chunk.data());
		}
		~Shader()
		{
			pshader_->Release();
		}

		void Apply()
		{
			_apply(pshader_);
		}

	private:
		T* pshader_;
	};
	typedef Shader<IDirect3DVertexShader9> VertexShader;
	typedef Shader<IDirect3DPixelShader9> PixelShader;
	IDirect3DVertexShader9* VertexShader::_create( const DWORD* codebin )
	{
		IDirect3DVertexShader9* sh = 0;
		HRESULT hr = s_dev->CreateVertexShader(codebin,&sh);
		assert(!hr);
		return hr? 0: sh;
	}
	void VertexShader::_apply( IDirect3DVertexShader9* pshader )
	{
		HRESULT hr = s_dev->SetVertexShader( pshader );
		(void)hr;
		assert(!hr);
	}
	IDirect3DPixelShader9* PixelShader::_create( const DWORD* codebin )
	{
		IDirect3DPixelShader9* sh = 0;
		HRESULT hr = s_dev->CreatePixelShader(codebin,&sh);
		assert(!hr);
		return hr? 0: sh;
	}
	void PixelShader::_apply( IDirect3DPixelShader9* pshader )
	{
		HRESULT hr = s_dev->SetPixelShader( pshader );
		(void)hr;
		assert(!hr);
	}
	
	class Material::Impl
	{
	public:
		Impl()
		{
			source_ = 0;
		}
		~Impl()
		{
			for( size_t Li = 0; Li < vertexshaders_.size(); ++Li ){
				delete vertexshaders_[ Li ];
			}
			vertexshaders_.clear();

			for( size_t Li = 0; Li < pixelshaders_.size(); ++Li ){
				delete pixelshaders_[ Li ];
			}
			pixelshaders_.clear();
		}

		chk::Material* source_;
		std::vector<VertexShader*> vertexshaders_;
		std::vector<PixelShader*> pixelshaders_;
	};

	Material::Material( chk::Material* chkmat ) : pimpl(new Impl())
	{
		//_VF[_
		{
			chk::ShaderCode* shader = chkmat->vertexshader();
			while( shader ){
				VertexShader* vsh = new VertexShader(shader);
				assert(vsh);
				pimpl->vertexshaders_.push_back(vsh);
				shader = shader->next();
			}
		}

		//sNZVF[_
		{
			chk::ShaderCode* shader = chkmat->pixelshader();
			while( shader ){
				PixelShader* psh = new PixelShader(shader);
				assert(psh);
				pimpl->pixelshaders_.push_back(psh);
				shader = shader->next();
			}
		}

		pimpl->source_ = chkmat;
	}
	Material::~Material()
	{
	}

	void Material::Apply( const com::matrix& world, const Environment& env )
	{
		const chk::Material& m = *pimpl->source_;
		s_dev->SetRenderState( D3DRS_CULLMODE, m.renderstate.cullmode );

		VertexShader* vsh = pimpl->vertexshaders_[0];
		vsh->Apply();

		PixelShader* psh = pimpl->pixelshaders_[0];
		psh->Apply();
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	Model::Model( chk::Model* chkmodel )
	{
		//}eA
		chk::Material* chkmat = chkmodel->materials();
		while( chkmat ){
			this->materials_.push_back(objptr<Material>(new Material(chkmat)));
			chkmat = chkmat->next();
		}

		//bV
		chk::Mesh* chkmesh = chkmodel->meshes();
		while( chkmesh ){
			this->meshes_.push_back(objptr<Mesh>(new Mesh(chkmesh)));
			chkmesh = chkmesh->next();
		}

		//^O
		chk::Tag* chktag = chkmodel->tags();
		while( chktag ){
			objptr<Tag> tag( new Tag() );
			tag->material = this->materials_[ chktag->material ];
			tag->mesh = this->meshes_[ chktag->mesh ];
			this->tags_.push_back(tag);
			chktag = chktag->next();
		}
	}
	Model::~Model()
	{
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	Sequencer::Sequencer()
	{
		this->env_ = 0;
		this->tags_.reserve(128);
	}
	Sequencer::~Sequencer()
	{
		this->flush_();
	}

	void Sequencer::flush_()
	{
		this->tags_.resize(0);
		this->env_ = 0;
	}
	void Sequencer::Begin( const Environment& env )
	{
		this->flush_();
		this->env_ = &env;
	}
	void Sequencer::Insert( Tag* tag )
	{
		this->tags_.push_back( tag );
	}
	void Sequencer::End()
	{
		Material* lastmat = 0;
		for( size_t Li = 0; Li < this->tags_.size(); ++Li ){
			Tag& tag = *this->tags_[ Li ];
			if( lastmat != tag.material ){
				lastmat = tag.material.get();
				lastmat->Apply( tag.world, *this->env_ );
			}
			tag.mesh->Draw();
		}
		s_dev->SetVertexShader(0);
		s_dev->SetPixelShader(0);
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	Actor::Actor()
	{
		this->pos_ = com::vector::zero();
	}
	Actor::~Actor()
	{
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	World::World()
	{
		scp::vmapi& vm = *scp::vmcontext::instance();

		vm.creg<Model>()
			;
		vm.creg<Actor>()
			.variable("pos",&Actor::GetPos,&Actor::SetPos)
			.variable("model",&Actor::GetModel,&Actor::SetModel)
			;
		vm.creg("world",this)
			.function("CreateActor",&World::CreateActor)
			;
	}
	World::~World()
	{
	}

	Actor* World::CreateActor()
	{
		objptr<Actor> actor(new Actor());
		this->actors_.push_back(actor);
		return actor.get();
	}

	void World::Update()
	{
		this->models_.resize(0);
		for( size_t Li = 0; Li < this->actors_.size(); ++Li ){
			Actor& actor = *this->actors_[ Li ];
			objptr<Model> model = actor.model_;
			if( model ){
				this->models_.push_back(model);
				com::matrix mat = com::matrix::translation(actor.pos_);
				for( size_t Lj = 0; Lj < model->tags_.size(); ++Lj ){
					model->tags_[ Lj ]->world = mat;
				}
			}
		}
	}
	void World::Draw()
	{
		this->opaque_.Begin( this->env_ );
		for( size_t Li = 0; Li < this->models_.size(); ++Li ){
			Model& model = *this->models_[ Li ];
			for( size_t Lj = 0; Lj < model.tags_.size(); ++Lj ){
				this->opaque_.Insert( model.tags_[ Lj ].get() );
			}
		}
		this->opaque_.End();
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}
