//	shive's code 2008.08.19
//=============================================================================

#include "stdafx.h"
#include "app.h"
#include "../fwk/Loader.h"
#include "../fwk/Model.h"
#include "../com/debug.h"
#include "../mem/Allocator.h"
#include "../scp/vmapi.h"

namespace shive { namespace hoge {

	using com::tick;
	using com::timer;
	using com::vector;
	using com::matrix;
	using com::degree;
	using com::radian;
	using com::aabb;
	using com::debug;
	using fwk::Gadget;

	#include "console.inl"
	#include "camera.inl"
	#include "grid.inl"

	App::App() {
	}
	App::~App() {
	}

	//XNvg֘Ȁ
	void App::initvm( scp::vmapi& vmc )
	{
		//J
		vmc.creg("camera",this->camera_.get())
			.variable("eye",&Camera::geteye,&Camera::seteye)
			.variable("aim",&Camera::getaim,&Camera::setaim)
			;
	}

	//
	bool App::init()
	{
		HRESULT hr = 0;

		//foCX̃ftHgݒ
		device dev;
		hr = dev->SetRenderState( D3DRS_LIGHTING, false );
		hr = dev->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );

		//ReLXgݒ
		this->loader_.reset( new fwk::Loader() );
		this->world_.reset( new fwk::World() );
		this->camera_.reset( new Camera( &this->world_->env().camera ) );
		this->grid_.reset( new Grid() );

		//XNvgւ̓o^
		scp::vmapi& vmc = *scp::vmcontext::instance();
		initvm(vmc);

		//C[vXNvgRpC
		this->mainthread_.reset(new scp::vmthread(vmc,1024));
		if( !this->mainthread_->dofile("data/main.nut",false,true) ){
			return false;
		}

		return true;
	}

	//I
	void App::term()
	{
		//XNvgI܂ŉ
		while( this->mainthread_->getvmstate() == scp::vmapi::suspended ){
			this->mainthread_->pushbool(false);
			if( !this->mainthread_->wakeupvm(true,false,true) ){
				break;
			}
		}
		this->mainthread_.reset();

		this->grid_.reset();
		this->camera_.reset();
		this->world_.reset();
		this->loader_.reset();
	}

	//`揈
	void App::draw()
	{
		HRESULT hr = 0;

		static timer s_fps;
		Console::instance().WriteLine("DRAW: %.1f FPS",(float)tick::TickPerSecond/s_fps.update().get());

		//ʃNA
		device dev;
		hr = dev->Clear( 0, 0, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER | D3DCLEAR_STENCIL, D3DCOLOR_XRGB(160,160,160), 1.0f, 0 );

		//Jݒ
		this->camera_->Apply();

		//Obh`
		this->grid_->Draw();

		//[h`
		this->world_->Draw();

		//Qc`
		Console::instance().Flush();
	}

	//XViƗXbhĂ΂j
	bool App::update( tick delta )
	{
		//com::debug::writeline("[update]");

		//XNvgN
		this->mainthread_->pushbool(true);
		if( !this->mainthread_->wakeupvm(true,false,true) ){
			return false;
		}

		//JXV
		this->camera_->Update( delta );

		//V[XV
		this->world_->Update();

		return true;
	}

	//}EX
	bool App::OnMouseMove( uint buttons, const POINT& mpt )
	{
		return this->camera_->OnMouseMove( buttons, mpt );
	}

}}
