//	shive's code 2008.08.19
//=============================================================================

	class Camera : noncopyable {
	protected:
		Camera() : info(0) {}
	public:
		explicit Camera( fwk::CameraInfo* target ) : info( target )
		{
			info->proj = matrix::perspetive(degree(35.0f),window().aspect(),1e-2f,4e3f);
			info->eye = vector(0.0f,7.0f,-12.0f);
			info->aim = vector::zero();
			info->up = vector::yunit();
			this->recalcUpVector_();

			POINT mpt;
			::GetCursorPos( &mpt );
			this->OnMouseMove( 0, mpt );
			this->Update(tick(0));
		}
		bool OnMouseMove( uint buttons, const POINT& mpt )
		{
			POINT move = { mpt.x - lastmpt.x, mpt.y - lastmpt.y };
			lastmpt = mpt;
			if( buttons & MK_LBUTTON ){
				vector dir = info->eye - info->aim;
				float sc = vector::yunit().dot3(info->up);
				sc = (sc > 0.0f)? -1.0f: 1.0f;
				dir = matrix::yrotation(radian(move.x*sc*1e-2f)).affineTransform(dir);
				info->up = matrix::yrotation(radian(move.x*sc*1e-2f)).affineTransform(info->up);
				vector axis = dir.norm3().cross(info->up).norm3();
				dir = matrix::rotation(axis,radian(move.y*1e-2f)).affineTransform(dir);
				info->up = matrix::rotation(axis,radian(move.y*1e-2f)).affineTransform(info->up);
				info->eye = dir + info->aim;
				recalcUpVector_();
			}
			else if( buttons & MK_RBUTTON ){
				vector dir = info->eye - info->aim;
				dir *= 1.0f - move.x * 2e-3f;
				info->eye = info->aim + dir;
				recalcUpVector_();
			}
			else if( buttons & MK_MBUTTON ){
				vector dir = info->eye - info->aim;
				float sc = (float)dir.length3() * 1e-3f;
				vector track = info->up * (move.y * sc);
				vector axis = dir.norm3().cross(info->up).norm3();
				track += axis * (move.x * sc);
				info->aim += track;
				info->eye += track;
				recalcUpVector_();
			}
			else{
				return false;
			}
//			debug::writeline("eye: %.3f %.3f %.3f",info->eye[0],info->eye[1],info->eye[2]);
//			debug::writeline("aim: %.3f %.3f %.3f",info->aim[0],info->aim[1],info->aim[2]);
//			debug::writeline(" up: %.3f %.3f %.3f",info->up[0],info->up[1],info->up[2]);
//			debug::writeline();
			return true;
		}
		void Update( tick delta )
		{
			(void)delta;
			info->view = matrix::lookAt(info->eye,info->aim,info->up);
		}
		void Apply()
		{
			HRESULT hr = 0;

			device dev;
			hr = dev->SetTransform( D3DTS_VIEW, info->view );
			hr = dev->SetTransform( D3DTS_PROJECTION, info->proj );

			Console::instance().WriteLine("EYE: %.2f %.2f %.2f / %.2f",info->eye[0],info->eye[1],info->eye[2],(float)(info->eye-info->aim).length3());
			Console::instance().WriteLine("AIM: %.2f %.2f %.2f",info->aim[0],info->aim[1],info->aim[2]);
			Console::instance().WriteLine(" UP: %.2f %.2f %.2f",info->up[0],info->up[1],info->up[2]);

			//App::DrawLine(info->aim,info->aim+info->up,D3DCOLOR_XRGB(0,0,0));
			//App::DrawLine(info->aim,info->aim+info->up.cross((info->eye-info->aim).norm3()).norm3(),D3DCOLOR_XRGB(0,0,0));
		}

		const vector& geteye() const {
			return this->info->eye;
		}
		void seteye( const vector& v ) {
			this->info->eye = v;
		}
		const vector& getaim() const {
			return this->info->aim;
		}
		void setaim( const vector& v ) {
			this->info->aim = v;
		}

	private:
		//upxNg␳
		void recalcUpVector_()
		{
			vector ray = (info->eye - info->aim).norm3();
			vector xaxis = ray.cross(info->up).norm3();
			info->up = xaxis.cross(ray).norm3();
		}
	private:
		fwk::CameraInfo* const info;
		POINT lastmpt;
	};
