//	shive's code 2008.09.15
//=============================================================================

#pragma once
#include "../types.h"
#include <assert.h>

#ifdef _DEBUG
#	define _(C) (assert(C))
#else
#	define _(C) (C)
#endif

namespace shive { namespace scp { namespace detail {

	template<typename U>
	struct arg {
		static U get( HSQUIRRELVM hvm, int index ) {
			return arg<U>::get(hvm,index);
		}
	};
	template<>
	struct arg<const char*> {
		static const char* get( HSQUIRRELVM hvm, int index ) {
			return vmapi(hvm).getstring(index+2);
		}
	};
	template<>
	struct arg<int> {
		static int get( HSQUIRRELVM hvm, int index ) {
			return vmapi(hvm).getinteger(index+2);
		}
	};
	template<>
	struct arg<float> {
		static float get( HSQUIRRELVM hvm, int index ) {
			return vmapi(hvm).getfloat(index+2);
		}
	};
	template<>
	struct arg<bool> {
		static bool get( HSQUIRRELVM hvm, int index ) {
			return vmapi(hvm).getbool(index+2);
		}
	};
	template<>
	struct arg<vmobj> {
		static vmobj get( HSQUIRRELVM hvm, int index ) {
			return vmapi(hvm).getstackobj(index+2);
		}
	};
	template<>
	struct arg<vmobj&> {
		static vmobj get( HSQUIRRELVM hvm, int index ){
			vmobj tmp = arg<vmobj>::get(hvm,index);
			return tmp;
		}
	};
	template<typename U>
	struct arg<U*> {
		static U* get( HSQUIRRELVM hvm, int index ) {
			_(creg_link_holder<tt<U>::x>::_registered());
			vmapi::vmtypes type = vmapi(hvm).gettype(index+2);
			switch(type){
			case vmapi::null:
				return 0;
			case vmapi::instance:
				{
					void* const ttag = creg_link_holder<tt<U>::x>::_typetag();
					U* p = static_cast<U*>(vmapi(hvm).getinstanceup(index+2,ttag));
					_(p);
					return p;
				}
			}
			_(false);
			return 0;
		}
	};
	template<typename U>
	struct arg<U&> {
		static U& get( HSQUIRRELVM hvm, int index ) {
			return *arg<U*>::get(hvm,index);
		}
	};
	/*
	template<typename U>
	struct arg<objptr<U>&> {
		static objptr<U> get( HSQUIRRELVM hvm, int index ) {
			return objptr<U>(arg<U*>::get(hvm,index));
		}
	};
	*/

}}}

#undef _
