//	shive's code 2008.09.22
//=============================================================================

#include "stdafx.h"
#include "vmapi.h"
#include "../com/debug.h"
#include "../com/matrix.h"
#include "../com/util.h"
#pragma warning(disable:4505)//QƂĂȂ[J֐͍폜܂B

using namespace shive;

static void debughook( scp::vmapi& vm, scp::vmapi::vmeventtype eventtype, const char* file, int line, const char* funcname );
static void test000( scp::vmapi& vmc );
static void test001( scp::vmapi& vmc );
static void test002( scp::vmapi& vmc );

int main( int, const char** )
{
	CRTSETDBGFLAG();
	setlocale(LC_ALL,"");

	scp::vmcontext vmc(1024);
//	vmc.setdebughook(&debughook);

	//test000(vmc);
	//test001(vmc);
	test002(vmc);

	return 0;
}

//œK}̂߂̊֐
#pragma optimize("",off)
static void dummyfunc(){}
#pragma optimize("",on)

//xeXg
void test002( scp::vmapi& vmc )
{
	com::debug::writeline("[test002]");

	com::timer tm;
	scp::vmthread vm(vmc,1024);

	//native
	tm.update();
	for(int Li=0;Li<1000*1000;++Li){dummyfunc();}
	com::debug::writeline("[for][native] %8d us",com::tick::usec(tm.update()).get());

	//vm
	SQCODE(vm,suspend();for(local Li=0;Li<1000*1000;++Li){});
	tm.update();
	vm.wakeupvm(false,false,true);
	com::debug::writeline("[for][script] %8d us",com::tick::usec(tm.update()).get());

	struct Foo {
		Foo() {
			num = 0;
		}
		void inc() {
			++num;
			dummyfunc();
		}
		int num;
	};
	Foo foo;
	vm.creg("foo",&foo)
		.function("inc",&Foo::inc);

	//native
	tm.update();
	for(int Li=0;Li<1000*1000;++Li){foo.inc();}
	com::debug::writeline("[inc][native] %8d us",com::tick::usec(tm.update()).get());

	//vm
	SQCODE(vm,
		suspend();
		for(local Li=0;Li<1000*1000;++Li){foo.inc();}
		);
	tm.update();
	vm.wakeupvm(false,false);
	com::debug::writeline("[inc][script] %8d us",com::tick::usec(tm.update()).get());

	//vm
	SQCODE(vm,
		local bar = class{
			num = 0;
			function inc() {
				++num;
			}
		}();
		suspend();
		for(local Li=0;Li<1000*1000;++Li){bar.inc();}
	);
	tm.update();
	vm.wakeupvm(false,false);
	com::debug::writeline("[inc][script] %8d us",com::tick::usec(tm.update()).get());
}

//C[veXg
void test001( scp::vmapi& vmc )
{
	com::debug::writeline("[test001]");

	class data_t {
	public:
		const com::vector& getpos() const {
			return pos;
		}
		void setpos( const com::vector& _pos ) {
			pos = _pos;
		}
	private:
		com::vector pos;
	} data;

	vmc.creg("data",&data)
		.variable("pos",&data_t::getpos,&data_t::setpos);

	scp::vmthread thread(vmc,1024);
	SQCODE(thread,
		local counter = 0;										\n
		print("start\n");										\n
		while(suspend()&&counter<30){							\n
			local pos = null;									\n
			pos = data.pos;										\n
			pos.y += 0.05;										\n
			data.pos = pos;										\n
			++counter;											\n
		}														\n
		print("finish\n");										\n
	);
	while(thread.getvmstate() == scp::vmapi::suspended){
		thread.pushbool(true);
		thread.wakeupvm(true,false,true);
	}
}

//NXo^eXg
void test000( scp::vmapi& vmc )
{
	com::debug::writeline("[test000]");

	class bbb {
	public:
		bbb() {
			adr = (uintptr_t)this;
		}
		void echo() {
			com::debug::writeline("[bbb] 0x%08X",(uintptr_t)this);
		}
		scp::vmobj gogo() {
			scp::vmapi& vm = *scp::vmcontext::instance();
			vm.pushstring("gogo");
			return vm.pop();
		}
	private:
		uintptr_t adr;
	};
	class ccc
	{
	public:
	};
	class aaa : public virtual ccc
	{
	public:
		aaa() {
			com::debug::writeline("[aaa] this=0x%08X",(uintptr_t)this);
			counter = 99;
		}
		virtual ~aaa() {
			com::debug::writeline("[aaa] dtor");
		}
		void trace() const {
			com::debug::writeline("c=%d",counter);
		}
		void setcount( int c ) {
			counter = c;
		}
		int getcount() const {
			return counter;
		}
		scp::vmobj setobj( scp::vmobj obj ) {
			return obj;
		}
		void copy( bbb& x ) {
			b = x;
		}
		bbb& ref() {
			return c;
		}
	private:
		bbb b;
		bbb c;
		int counter;
	};

	//if(false)
	{
		scp::vmthread thread(vmc,1024);
		scp::vmthread thread2 = thread;
		thread2 = thread;
		thread2.creg<aaa>("aaa")
			.constant("constant_integer",999)
			.constant("constant_float",12.3f)
			.constant("constant_string","hogehoge")
			.variable("variable_integer",777)
			.variable("variable_float",3.14f)
			.variable("variable_string","foobar")
			.variable("count",&aaa::getcount,&aaa::setcount)
			.function("trace",&aaa::trace)
			.function("ref",&aaa::ref)
			.function("setobj",&aaa::setobj)
			.function("copy",&aaa::copy)
			;
		thread2.creg<bbb>("bbb")
			.function("echo",&bbb::echo)
			.function("gogo",&bbb::gogo)
			;
	
		SQCODE(thread,

			local a = aaa();

			print(a+"\n");

			print(a.ref()+"\n");
			a.ref().echo();
			print(a.ref().gogo()+"\n");
			a.setobj(a);

			a.copy(a.ref());

			local ppp = function() : (a) {
				print("----\n");
				print("aaa.constant_integer="+aaa.constant_integer+"\n");
				print("aaa.constant_float="+aaa.constant_float+"\n");
				print("aaa.constant_string="+aaa.constant_string+"\n");
				print("aaa.variable_integer="+aaa.variable_integer+"\n");
				print("aaa.variable_float="+aaa.variable_float+"\n");
				print("aaa.variable_string="+aaa.variable_string+"\n");
				//print("aaa.count="+aaa.count+"\n");
				a.trace();
				print("a.constant_integer="+a.constant_integer+"\n");
				print("a.constant_float="+a.constant_float+"\n");
				print("a.constant_string="+a.constant_string+"\n");
				print("a.variable_integer="+a.variable_integer+"\n");
				print("a.variable_float="+a.variable_float+"\n");
				print("a.variable_string="+a.variable_string+"\n");
				print("a.count="+a.count+"\n");
				print("\n");
			}

			ppp();

			//a.constant_integer = 0;
			//a.constant_float = 0;
			//a.constant_string = 0;
			a.variable_integer = 0;
			a.variable_float = 0;
			a.variable_string = 0;
			a.count = 0;
			
			ppp();

			a.dispose();

			);

		SQSETVAR(thread,hoge,
			(["one","two","san"])
			);
		scp::vmobj vmo = SQGETVAR(thread,hoge[2]);
		com::debug::writeline("hoge[2]=%s",vmo.torawstring());
	}

	//if(false)
	{
		//array
		vmc.setvar("ary","[1,3,5,7,11,13]");
		scp::vmobj ary = vmc.getvar("ary");
		com::debug::writeline("---- array ----");
		com::debug::writeline("ary.len=%d",ary.getsize());
		for( int Li = 0; Li < ary.getsize(); ++Li ){
			com::debug::writeline("ary[%d]=%d",Li,(int)(ary[Li]));
		}
		com::debug::writeline("ary[%d]=%d",0,(int)(ary[0]));
		com::debug::writeline("ary[%d]=%d",2,(int)(ary[2]));
		com::debug::writeline("ary[%d]=%d",5,(int)(ary[5]));

		//table
		vmc.setvar("tbl","{[0]=1,[1]=3,name=\"hoge\",[2]=5,[3]=7,type=\"someone\",[4]=11,[5]=13}");
		scp::vmobj tbl = vmc.getvar("tbl");
		com::debug::writeline("---- table ----");
		com::debug::writeline("tbl.len=%d",tbl.getsize());
		for( int Li = 0; Li < tbl.getsize(); ++Li ){
			com::debug::writeline("tbl[%d]=%d",Li,(int)(ary[Li]));
		}
		com::debug::writeline("tbl[%d]=%d",0,(int)(tbl[0]));
		com::debug::writeline("tbl[%d]=%d",2,(int)(tbl[2]));
		com::debug::writeline("tbl[%d]=%d",5,(int)(tbl[5]));
		com::debug::writeline("tbl[%s]=%s","name",(const char*)(tbl["name"]));
		com::debug::writeline("tbl[%s]=%s","type",(const char*)(tbl["type"]));
		scp::vmiter iter = tbl;
		while(!iter.isend()){
			std::string key = (*iter);
			std::string value = iter.value();
			com::debug::writeline("tbl[%s]=%s",key.c_str(),value.c_str());
			++iter;
		}
	}
}

void debughook( scp::vmapi& vm, scp::vmapi::vmeventtype eventtype, const char* file, int line, const char* funcname )
{
	(void)vm;
	switch(eventtype){
	case scp::vmapi::kEventTypeStep:
		com::debug::writeline("%s(%d): [%s][STEP]",file,line,funcname);
		break;
	case scp::vmapi::kEventTypeCall:
		com::debug::writeline("%s(%d): [%s][CALL]",file,line,funcname);
		break;
	case scp::vmapi::kEventTypeReturn:
		com::debug::writeline("%s(%d): [%s][RETURN]",file,line,funcname);
		break;
	}
}
