//	shive's code 2008.09.08
//=============================================================================

#include "functrait.h"

template<typename T>
class creg {
public:
	explicit creg( HSQUIRRELVM _hvm, const char* name ) : hvm(_hvm)
	{
		sq_pushroottable(hvm);
		sq_pushstring(hvm,name,-1);
		
		_(sq_newclass(hvm,false));
		_(sq_setclassudsize(hvm,-1,sizeof(T)));
		
		//ctor
		sq_pushstring(hvm,"constructor",-1);
		sq_newclosure(hvm,&call_constructor,0);
		_(sq_newslot(hvm,-3,false));
		
		//getter
		sq_pushstring(hvm,"_get",-1);
		sq_newclosure(hvm,&getter_,0);
		_(sq_newslot(hvm,-3,false));
		
		//setter
		sq_pushstring(hvm,"_set",-1);
		sq_newclosure(hvm,&setter_,0);
		_(sq_newslot(hvm,-3,false));
	}
	~creg()
	{
		_(sq_newslot(hvm,-3,false));
		sq_pop(hvm,1);
	}

public:
	//֐o^
	template<typename U>
	creg& function( const char* name, U pfn )
	{
		sq_pushstring(hvm,name,-1);
		sq_pushuserpointer(hvm,*(void**)&pfn);
		sq_newclosure(hvm,&fn<U>::call,1);
		const int narg = functrait<U>::narg + 1;
		const functrait<U>::typemask_t typemask = functrait<U>::gettypemask();
		_(sq_setparamscheck(hvm,narg,typemask.s));
		_(sq_setnativeclosurename(hvm,-1,name));
		_(sq_newslot(hvm,-3,false));
		return (*this);
	}
	//ϐo^
	template<typename U>
	creg& variable( const char* name, U(T::*getter)() const, void (T::*setter)(U) )
	{
		char funcname[ 256 ];
		if(getter){
			sprintf(funcname,"%s_getter",name);
			this->function(funcname,getter);
		}
		if(setter){
			sprintf(funcname,"%s_setter",name);
			this->function(funcname,setter);
		}
		return (*this);
	}
	//萔o^
	creg& constant( const char* name, int value )
	{
		sq_pushstring(hvm,name,-1);
		sq_pushinteger(hvm,value);
		_(sq_newslot(hvm,-3,true));//statico^邾
		return (*this);
	}
	creg& constant( const char* name, float value )
	{
		sq_pushstring(hvm,name,-1);
		sq_pushfloat(hvm,value);
		_(sq_newslot(hvm,-3,true));//statico^邾
		return (*this);
	}
	creg& constant( const char* name, const char* value )
	{
		sq_pushstring(hvm,name,-1);
		sq_pushstring(hvm,value,-1);
		_(sq_newslot(hvm,-3,true));//statico^邾
		return (*this);
	}
	
private:
#include "test001-ctor-inl.h"
#include "test001-fn-inl.h"
	
	static int getter_( HSQUIRRELVM hvm )
	{
		const char* varname = 0;
		_(sq_getstring(hvm,2,&varname));
		char funcname[ 256 ];
		sprintf(funcname,"%s_getter",varname);
		sq_pushstring(hvm,funcname,-1);
		_(sq_rawget(hvm,1));
		sq_push(hvm,1);
		_(sq_call(hvm,1,true,true));
		return 1;
	}
	static int setter_( HSQUIRRELVM hvm )
	{
		const char* varname = 0;
		_(sq_getstring(hvm,2,&varname));
		char funcname[ 256 ];
		sprintf(funcname,"%s_setter",varname);
		sq_pushstring(hvm,funcname,-1);
		_(sq_rawget(hvm,1));
		sq_push(hvm,1);
		sq_push(hvm,3);
		_(sq_call(hvm,2,false,true));
		return 0;
	}
	
private:
	HSQUIRRELVM hvm;
};

