//	shive's code 2008.09.01
//=============================================================================

//Ql
//http://wikiwiki.jp/lua/?Squirrel_Lang%2Fch2

X <- {};
function X::org() {
	print("X::org()\n");
}
console <- {
	function writeline( str ) {
		print(str+"\n");
	}
}

function tostring( val )
{
	switch(typeof(val)){
	case "array":
		local str = "[";
		if(val.len()){
			foreach( x in val ){
				str+=::tostring(x)+",";
			}
			str = str.slice(0,-1);
		}
		return str + "]";
	case "table":
	case "class":
		local str = "{";
		if(val.len()){
			foreach( x, y in val ){
				str+=x+"="+tostring(y)+",";
			}
			str = str.slice(0,-1);
		}
		return str + "}";
	case "string":
		return "\""+val+"\"";
	case "null":
		return "null";
	default:
		return val.tostring();
	}
}

test <- {

	//string
	function test_print()
	{
		print(@"""hoge""\n");
		print("\"hoge\"\n");
		print(@"snj
قق
Ӂ[΁[
");
	}

	//in
	function test_in()
	{
		local array = ["aaa","bbb",100];
		print("array="+tostring(array)+"\n");
		for( local Li = -3; Li < 3 + 2; ++Li ){
			if( Li in array ){
				print(Li+" in array = yes\n");
			} else {
				print(Li+" in array = no\n");
			}
		}
		print("\n");
		
		local table = { hoge = 3, foo = 5, bar = 7 };
		print("table="+tostring(table)+"\n");
		print("hoge in table = "+(("hoge" in table)?"yes":"no")+"\n");
		print("moo in table = "+(("moo" in table)?"yes":"no")+"\n");
	}
	
	//varg
	function test_varg()
	{
		function hoge(...){
			print("varg=");
			for( local Li = 0; Li < vargc; ++Li ){
				print(vargv[Li]+" ");
			}
			print("\n");
		}
		print("hoge(\"aaa\",\"bbb\",\"ccc\")->");
		hoge("aaa","bbb","ccc");
		print("hoge(0,\"xxx\",{},[])->");
		hoge(0,"xxx",{},[]);
		print("hoge()->");
		hoge();
		print("hoge([])->");
		hoge([]);
	}

	//Rϐ
	function test_freevar()
	{
		local msg = "hallo:";
		local num = 100;
		local ary = ["aaa"];
		function foo() : (msg,num,ary){
			print(msg+num);
			foreach(val in ary){
				print(val);
			}
		}
		msg = "world:";
		num = 5;
		ary.append("bbb");
		function bar() : (msg,num,ary){//e[uւ̎QƂRs[̂"bbb"͕K\
			print(msg+num);
			foreach(val in ary){
				print(val);
			}
		}
		
		print("foo()=");
		foo();
		print("\n");
		print("bar()=");
		bar();
		print("\n");
	}

	//scope
	function test_scope()
	{
		local aaa="aaa_";
		{
			local hoge = "foo";
			print(aaa+hoge+"\n");//aaa͂̂܂܎g
		}
		{
			local hoge = "bar";
			print(aaa+hoge+"\n");//hoge̎QƂ͕ύXĂ
		}
		//print(hoge+"\n");//G[ɂȂ
	}

	//generator
	function test_generator()
	{
		function geny()
		{
			for( local Li = 'a'; Li < 'k'; ++Li ){
				yield Li;
			}
			return null;
		}
		local gtor = geny();
		local x;
		print("stat="+gtor.getstatus()+"\n");
		while( x = resume gtor ){
			print("stat="+gtor.getstatus()+" "+x.tochar()+"\n");
		}
		print("stat="+gtor.getstatus()+"\n");
	}
	
	//coroutine
	function test_coroutine()
	{
		function work( args )
		{
			foreach( val in args ){
				print(val+" ");
				if( suspend(val) ){
					print(" ");
				}
			}
		}
		local n = 0;
		local x = newthread(work);
		n = x.call(["hoge","foo","bar","aaa","bbb","ccc"]);
		while(x.getstatus()=="suspended"){
			n = x.wakeup( (n == "aaa")? true: false );
		}
		print(x.getstatus()+"\n");
	}

	//string
	function test_string()
	{
		local str = "Suteki";
		
		print("str="+str+"\n");
		print("str.len()="+str.len()+"\n");
		print("str.tolower()="+str.tolower()+"\n");
		print("str.toupper()="+str.toupper()+"\n");
		print("str.slice(3)="+str.slice(3)+"\n");
		print("str.slice(2,5)="+str.slice(2,5)+"\n");
		print("str.slice(0,-4)="+str.slice(0,-4)+"\n");
		print("\n");
		
		str = "13"
		print("str="+str+"\n");
		print("str.tointeger()*3="+str.tointeger()*3+"\n");
		print("\n");
	}
	
	//array
	function test_array()
	{
		local ary = [3,5,7,"aaa","bbb","ccc"];
		
		print("ary="+tostring(ary)+"\n");
		print("ary.len()="+ary.len()+"\n");
		ary.append({});
		print("ary.append({})="+tostring(ary)+"\n");
		ary.extend([9,5,7]);
		print("ary.extend([9,5,7])="+tostring(ary)+"\n");
		ary.push(99);
		print("ary.push(99))="+tostring(ary)+"\n");
		ary.pop();
		print("ary.pop()="+tostring(ary)+"\n");
		print("ary.top()="+ary.top()+"\n");
		ary.remove(5);
		print("ary.remove(5)="+tostring(ary)+"\n");
		ary.reverse();
		print("ary.reverse()="+tostring(ary)+"\n");
		function fn(a,b) {
			return a.tostring().len() - b.tostring().len();
		}
		ary.sort(fn);
		print("ary.sort(fn)="+tostring(ary)+"\n");
		ary.clear();
		print("ary.clear()="+tostring(ary)+"\n");
	}
	
	//weakref
	function test_weakref()
	{
		local ary = ["hoge"];
		local wref = ary.weakref();
		
		print("ary="+tostring(ary)+"\n");
		print("wref="+wref+"\n");
		print("wref.ref()="+tostring(wref.ref())+"\n");
		print("\n");
		
		ary.push("uuu");
		print("ary="+tostring(ary)+"\n");
		print("wref="+wref+"\n");
		print("wref.ref()="+tostring(wref.ref())+"\n");
		print("\n");
		
		ary=5;
		print("ary="+tostring(ary)+"\n");
		print("wref="+wref+"\n");
		print("wref.ref()="+tostring(wref.ref())+"\n");
		print("\n");
	}

	//try-catch
	function test_enum_const()
	{
		enum hoge {
			xxx = 5,
			yyy = 11.1,
			zzz = "foo"
		};
		print("hoge.xxx="+hoge.xxx+"\n");
		print("hoge.yyy="+hoge.yyy+"\n");
		print("hoge.zzz="+hoge.zzz+"\n");
		
		//ȌύXt
		const uuu = 7;
		const vvv = 33.3;
		const www = "bar"
		print("uuu="+uuu+"\n");
		print("vvv="+vvv+"\n");
		print("www="+www+"\n");
		
		//www = "uuu"		//ʂ̑͂mf
		const www = "sss";	//const͂nj
		print("www="+www+"\n");
		
		//㏑͂ł
		enum hoge {
			uuu= "foo"
		};
		print("hoge.uuu="+hoge.uuu+"\n");
	}

	//try-catch
	function test_trycatch()
	{
		try{
			console.writeline("$ thorow \"hoge\"");
			throw "hoge";
		}
		catch( ex ){
			print("exception="+ex+"\n");
		}
		
		try{
			console.writeline("$ assert(\"hoge\")");
			assert(!"assert");
		}
		catch( ex ){
			print("exception="+ex+"\n");
		}
	}
	
	//function
	function test_function()
	{
		function errorhandler( str ) {
			console.writeline("error!! = "+str);
		}
		seterrorhandler(errorhandler);

		this.hoge <- function( aaa ) {
			print("thos.hoge("+aaa+")\n");
		}
		this.hoge(11);
		
		X.org();
		
		local T = {
			function hoge() {
				print("T.hoge()\n");
			}
		};
		T.foo <- function() {
			print("T.foo()\n");
		}
		T.hoge();
		T.foo();
		
		T.U <- {};
		T.U.bar <- function() {
			print("T.U.bar()\n");
		}
		T.U.bar();
		
		local T = {
			U = {
				function uuu() {
					print("T.U.uuu()\n");
				}
			}
		}
		T.U.uuu();
		
		console.writeline("");
		function doerror( ... ) {
			console.writeline("this="+this);
			console.writeline("vargc="+vargc);
			throw("ځ[");
		}
		
		//call: G[nhĂ΂
		try{
			console.writeline("$ doerror.call(this,0,1,2)");
			doerror.call(this,0,1,2);
		}
		catch(ex){
			console.writeline("-> exception!!="+ex);
		}
		console.writeline("");
		
		//pcall: G[nhĂ΂Ȃ
		try{
			console.writeline("$ doerror.pcall(this,0,1,2)");
			doerror.pcall(this,0,1,2);
		}
		catch(ex){
			console.writeline("-> exception!!="+ex);
		}
		console.writeline("");
		
		//acall: this܂ނzňniG[nhĂ΂j
		try{
			console.writeline("$ doerror.acall([this,1,2])");
			doerror.acall([this,1,2]);
		}
		catch(ex){
			console.writeline("-> exception!!="+ex);
		}
		console.writeline("");
		
		//acall: this܂ނzňniG[nh͌Ă΂Ȃj
		try{
			console.writeline("$ doerror.pacall([this,1,2])");
			doerror.pacall([this,1,2]);
		}
		catch(ex){
			console.writeline("-> exception!!="+ex);
		}
		console.writeline("");
		
		//bindenv(env)
		//clones the function(aka closure) and bind the enviroment object to it(table,class or instance).
		//the this parameter of the newly create function will always be set to env.
		//Note that the created function holds a weak reference to its environment object so cannot be used to control its lifetime. 

		seterrorhandler(null);
		
		console.writeline("delete this.hoge");
		delete this.hoge;
	}
	
	//class
	function test_class()
	{
		//::T <- {//O[oɒ`Ȃ炱
		local T = {
			aaa = class {
				constructor() {
					console.writeline("(ctor aaa)");
					num = 1;
				}
				</ name="[attr] aaa.somemsg" />
				function somemsg() {
					console.writeline("aaa::somemsg");
					console.writeline("num="+this.num);
					console.writeline("xxx="+this.xxx);
				}
				</ name="[attr] aaa.ԍ" />
				num = null;
				static xxx = 11;
				
				gomi = "gomi";
			}
		}
		//TO[ȍꍇɌ function T::aaa::doit() Ƃłnj
		T.aaa.doit <- function() {
			this.somemsg();
		}
		//class̃Xbg͏Ȃ
		try{
			console.writeline("$ delete T.aaa.gomi");
			delete T.aaa.gomi;
		}
		catch(ex){
			console.writeline("exception: "+ex);
		}
		console.writeline("");
		
		class T.bbb extends T.aaa {
			constructor() {
				console.writeline("(ctor bbb)");
				getclass().parent.constructor();	//NX̃RXgN^Ăяo
				++num;
			}
			</ name="[attr] bbb.somemsg" />
			function somemsg() {
				console.writeline("bbb::somemsg");
				console.writeline("num="+this.num);
				console.writeline("xxx="+this.xxx);
			}
		};
		
		local a = T.aaa();
		a.doit();
		console.writeline("$ typeof(aaa) = "+typeof(T.aaa));
		console.writeline("$ aaa.parent = "+T.aaa.parent);
		console.writeline("$ typeof(a) = "+typeof(a));
		console.writeline("$ aaa.somemsg.name = "+T.aaa.getattributes("somemsg").name);
		console.writeline("$ aaa.num.name = "+T.aaa.getattributes("num").name);
		console.writeline("$ a instanceof aaa = "+(a instanceof T.aaa));
		console.writeline("$ a instanceof bbb = "+(a instanceof T.bbb));
		console.writeline("");
		
		//instancẽXbgȂ
		try{
			console.writeline("$ delete a.gomi");
			delete a.gomi;
		}
		catch(ex){
			console.writeline("exception: "+ex);
		}
		console.writeline("");
		
		local b = T.bbb.instance();	//constructorĂяoɃCX^X
		console.writeline("$ b.num = "+b.num);
		console.writeline("$ b.xxx = "+b.xxx);
		b.constructor();			//IɌĂяo
		b.doit();
		console.writeline("$ typeof(bbb) = "+typeof(T.bbb));
		console.writeline("$ bbb.parent = "+T.bbb.parent);
		console.writeline("$ typeof(b) = "+typeof(b));
		console.writeline("$ bbb.somemsg.name = "+T.bbb.getattributes("somemsg").name);
		console.writeline("$ bbb.num.name = "+T.bbb.getattributes("num").name);
		console.writeline("$ b instanceof aaa = "+(b instanceof T.aaa));
		console.writeline("$ b instanceof bbb = "+(b instanceof T.bbb));
		console.writeline("");
		
		//clone͎QƂRs[邾̐󂢃Rs[
		local c = clone b;
		c.doit();
		console.writeline("$ typeof(c) = "+typeof(c));
		console.writeline("$ c instanceof aaa = "+(c instanceof T.aaa));
		console.writeline("$ c instanceof bbb = "+(c instanceof T.bbb));
		console.writeline("");
	}
	
	//static in class
	function test_staticmember()
	{
		class aaa {
			static uuu = 1;
			sss = 3;
		};
		local a = aaa();

		print("----\n");
		print("aaa.uuu="+aaa.uuu+"\n");
		print("a.uuu="+a.uuu+"\n");
		print("aaa.sss="+aaa.sss+"\n");
		print("a.sss="+a.sss+"\n");
		print("\n");

		print("aaa.uuu=5\n");	try{ aaa.uuu = 5; } catch( ex ){ print("-> "+ex+"\n"); }
		print("a.uuu=7\n");		try{ a.uuu = 7; } catch( ex ){ print("-> "+ex+"\n"); }
		print("aaa.sss=11\n");	try{ aaa.sss = 11; } catch( ex ){ print("-> "+ex+"\n"); }
		print("a.sss=13\n");	try{ a.sss = 13; } catch( ex ){ print("-> "+ex+"\n"); }
		print("\n");

		print("----\n");
		print("aaa.uuu="+aaa.uuu+"\n");
		print("a.uuu="+a.uuu+"\n");
		print("aaa.sss="+aaa.sss+"\n");
		print("a.sss="+a.sss+"\n");
		print("\n");
	}

	//delegate
	function test_delegate()
	{
		local aaa = {
			function say() {
				console.writeline("my name is "+myname);
				console.writeline("my parent is "+parent);
			}
			myname = "aaa"
		}
		console.writeline("$ aaa.say");
		aaa.say();
		console.writeline("");
		
		local bbb = delegate aaa : {
			myname = "bbb"
		}
		console.writeline("$ bbb.say");
		bbb.say();//delegateɂaaa.say()Ă΂
		console.writeline("");
		
		//clone͎QƂRs[邾̐󂢃Rs[
		local ccc = clone bbb;
		console.writeline("$ ccc.say");
		ccc.say();//delegateɂaaa.say()Ă΂
		console.writeline("");
	}
	
	//standard string library
	function test_sqstdstring()
	{
		//format(formatstr,...)
		console.writeline(@"$ format(""%s=%d\n"",""hoge"",5)");
		print(format("%s=%d\n","hoge",5));
		console.writeline("");
		
		//lstrip(str),rstring(str),strip(str)
		console.writeline(@"$ lstrip(""      hoge         "")");
		print(lstrip("      hoge         ")+"<\n");
		console.writeline(@"$ rstrip(""      hoge         "")");
		print(rstrip("      hoge         ")+"<\n");
		console.writeline(@"$ strip(""      hoge         "")");
		print(strip("      hoge         ")+"<\n");
		console.writeline("");
		
		//split(str,sep)
		console.writeline(@"$ split(""hoge foo bar"","" "")");
		console.writeline(::tostring(split("hoge foo bar"," ")));
		console.writeline("");
		
		//regexp(pattern)
		local str = "$*# ugougo 78! ruga"
		local pattern = "(([a-zA-Z]+) ([0-9]+))";
		local rx = regexp(pattern);
		console.writeline(format(@"$ rx = regexp(""%s"")",pattern));
		console.writeline(format(@"$ str = ""%s""",str));
		
		//rx.capture(str[,start])
		console.writeline(@"$ rx.capture(str)");
		foreach(i,v in rx.capture(str)){
			console.writeline("match["+i+"]: "+str.slice(v.begin,v.end));
		}
		
		//rx.match(str)
		console.writeline(@"$ rx.match(str)");
		console.writeline(::tostring(rx.match(str)));
		
		//rx.search(str[,start])
		console.writeline(@"$ rx.search(str)");
		console.writeline(::tostring(rx.search(str)));
	}
	
	/*
	//metamethod
	function test_metamethod()
	{
		//_set
		//_get
		//_newslot
		//_delslot
		//_add
		//_sub
		//_mul
		//_div
		//_unm
		//_typeof
		//_cmp
		//_call
		//_cloned
		//_nexti
		//_tostring
		//_inherited
		//_newmember
	}
	
	//gݍ݊֐
	function test_integratedfunctions()
	{
		//array(size,fill)
		//getroottable
		//compilestring(string[,buffername]);
		//type(obj)
		
		//getstackinfos(level)
	}
	
	//ftHgϏ
	function test_defaultdelegate()
	{
		//table
		//	len
		//	rawget
		//	rawdelete
		//	rawin
		//	weakref
		//	tostring
		//class
		//	instance
		//	getattributes
		//	rawin
		//	weakref
		//	tostring
		//instance
		//	getclass
		//	rawin
		//	weakref
		//	tostring
	}
	*/
	
	ugauga = "uuu",//֐Ȃ̂ŎsȂ

}

//test all
function test_all()
{
	console.writeline("Version='"+_version_);
	console.writeline("Unicode="+((_charsize_>1)?"yes":"no"));
	console.writeline("64bit="+((_intsize_>4)?"yes":"no"));
	console.writeline("");
	
	foreach( key, val in test ){
		//֐s
		if(typeof(val)=="function"){
			print("---- ---- ---- ----\n");
			print("["+key+"]\n");
				val();
			print("\n");
			collectgarbage();//GC
		}
	}
}
test_all();

