using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using seg;
using seg.d3dx;
using seg.dgr;
using dgr = seg.dgr;
using sg = seg.sg;

namespace app
{
	public partial class ScreenControl : UserControl
	{
		dgr.Screen screen_ = null;

		public ScreenControl()
		{
			InitializeComponent();

			this.Load     += this.ScreenControl_Load;
			this.Disposed += this.ScreenControl_Disposed;
			this.Resize   += this.ScreenControl_Resize;

			/*
			this.timer1.Interval = 1000 / 30;//30FPS
			this.timer1.Tick += this.timer1_Tick;
			this.timer1.Enabled = true;
			//*/
		}
		protected override void OnPaintBackground( PaintEventArgs e )
		{
			//base.OnPaintBackground( e );
		}

		public float Aspect
		{
			get { return this.screen_.Aspect; }
		}

		void ScreenControl_Load( object sender, EventArgs args )
		{
			this.screen_ = dgr.Screen.Create(
				this.Handle,
				Format.A8R8G8B8,
				Format.D24S8,
				MultiSampleType.None );
		}
		void ScreenControl_Disposed( object sender, EventArgs args )
		{
			this.screen_.Dispose();
			this.screen_ = null;
		}
		protected override void OnPaint( PaintEventArgs e )
		{
			DGR.SetRenderTarget(0,this.screen_.BackBuffer);
			DGR.SetDepthStencilSurface(this.screen_.DepthStencilSurface);

			base.OnPaint( e );

			this.screen_.Present();
		}
		void ScreenControl_Resize( object sender, EventArgs args )
		{
			if( this.screen_ != null ){
				this.screen_.Resize();
				this.Invalidate();
			}
		}
		void timer1_Tick( object sender, EventArgs args )
		{
			this.Refresh();
		}
	}
}
