#pragma once
#include "../Object.h"

namespace seg { namespace dgr {

	class Context;
	class Surface;

	//! XN[
	class SEGEXPORT Screen : public Object
	{
	public:
		Screen( const intrptr<Context>& context, IDirect3DSwapChain9* swc, IDirect3DSurface9* dsbuf );
		virtual ~Screen();

		Surface* GetBackBuffer() const
		{
			return this->backbuf_.get();
		}
		Surface* GetDepthStencilSurface() const
		{
			return this->dsbuf_.get();
		}

		float GetAspect() const;

		void Present()
		{
			this->swapchain_->Present(0,0,0,0,0);
		}
		void Resize();

	private:
		D3DPRESENT_PARAMETERS pp_;
		const intrptr<Context> context_;
		IDirect3DSwapChain9* swapchain_;
		intrptr<Surface> backbuf_;
		intrptr<Surface> dsbuf_;
		float aspect_;
	};

}}
