#pragma once
#include "../Object.h"

namespace seg { namespace dgr {

	class Context;

	class SEGEXPORT Stream : public Object
	{
	public:
		Stream( IDirect3DVertexDeclaration9* decl, IDirect3DVertexBuffer9* vbuf, IDirect3DIndexBuffer9* ibuf, int stride )
		{
			D3DVERTEXBUFFER_DESC dv;
			D3DINDEXBUFFER_DESC di;
			memset(&dv,0,sizeof(dv));
			memset(&di,0,sizeof(di));

			this->decl_ = decl;
			this->vbuf_ = vbuf;
			if( this->vbuf_ ){
				this->vbuf_->GetDesc(&dv);
			}
			this->ibuf_ = ibuf;
			if( this->ibuf_ ){
				this->ibuf_->GetDesc(&di);
			}

			this->stride_ = stride;
			this->nbVertices_ = dv.Size / stride;
			this->nbIndices_ = di.Size / sizeof(short);
		}
		virtual ~Stream()
		{
			if( this->decl_ ){
				this->decl_->Release();
				this->decl_ = 0;
			}
			if( this->vbuf_ ){
				this->vbuf_->Release();
				this->vbuf_ = 0;
			}
			if( this->ibuf_ ){
				this->ibuf_->Release();
				this->ibuf_ = 0;
			}
		}

	private:
		IDirect3DVertexDeclaration9* decl_;
		IDirect3DVertexBuffer9* vbuf_;
		IDirect3DIndexBuffer9* ibuf_;
		int stride_;
		int nbVertices_;
		int nbIndices_;

		friend class Context;
	};

}}
