#include "stdafx.h"
#include "Node.h"
#include "../dgr/Gadget.h"

namespace seg { namespace sg {

	//m[h̎ނ擾
	DLLEXPORT const char* segSgNodeTypeString( Node* node )
	{
		const char* const typestr[ SGNT_NUMBEROF ] = {
			"UNKNOWN",			//SGNT_UNKNOWN = 0,	//!< sl

			"NODE",				//SGNT_NODE = 1,		//!< m[hiO[vpj
			"TRANSFORM",		//SGNT_TRANSFORM,		//!< ʒu
			"TAG",				//SGNT_TAG,			//!< ^O
			"MESH",				//SGNT_MESH,			//!< bV
			"MATERIAL",			//SGNT_MATERIAL,		//!< }eA
			"TEXTURE",			//SGNT_TEXTURE,		//!< eNX`
			"UVSET",			//SGNT_UVSET,			//!< tuZbg
			"ENVELOPE",			//SGNT_ENVELOPE,		//!< Gx[v
			"MOTION",			//SGNT_MOTION,		//!< [V
			"CURVE",			//SGNT_CURVE,			//!< J[u
			"LIGHTSET",			//SGNT_LIGHTSET,		//!< CgZbg
			"LIGHT",			//SGNT_LIGHT,			//!< Cg
			"CAMERA",			//SGNT_CAMERA,		//!< J

			"GRID",				//SGNT_GRID,			//!< Obh
		};
		const NodeType nt = node->GetNodeType();
		if( 0 <= nt && nt < SGNT_NUMBEROF ){
			return typestr[nt];
		}
		assert(false);
		return "";
	}

	//V[Ot𑖍
	DLLEXPORT void segSgNodeTraverseDepthFirst( Node* node, TraverseBehavior (*traverser)(Node*,void*), void* arg )
	{
		node->TraverseDepthFirst(traverser,arg);
	}
	//ƂȂ̃m[h擾
	DLLEXPORT Node* segSgNodeGetSibling( Node* node )
	{
		return node->GetSibling();
	}
	//擪̎qm[h擾
	DLLEXPORT Node* segSgNodeGetChild( Node* node )
	{
		return node->GetChild();
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	void GridNode::DrawGrid() const
	{
		if(attr_->IsVisible()){
			dgr::Gadget::DrawGrid(attr_->center,16,1.0f);
		}
	}

	//ObhtO
	DLLEXPORT bool segSgGridNodeIsVisible( const GridNode* grid )
	{
		return grid->GetAttr()->IsVisible();
	}
	DLLEXPORT void segSgGridNodeSetVisible( const GridNode* grid, bool flag )
	{
		return grid->GetAttr()->SetVisible(flag);
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	//_
	DLLEXPORT void segSgCameraNodeGetEye( Vector* vec, const CameraNode* camera )
	{
		*vec = camera->GetEye();
	}
	//_
	DLLEXPORT void segSgCameraNodeGetAim( Vector* vec, const CameraNode* camera )
	{
		*vec = camera->GetAim();
	}
	//toxNg
	DLLEXPORT void segSgCameraNodeGetUpVector( Vector* vec, const CameraNode* camera )
	{
		*vec = camera->GetUpVector();
	}
	//toxNg
	DLLEXPORT void segSgCameraNodeLookAt( CameraNode* camera, const Vector& eye, const Vector& aim, const Vector& upv )
	{
		camera->LookAt(eye,aim,upv);
	}
	//Jړ
	DLLEXPORT void segSgCameraNodeTransform( CameraNode* camera, const Matrix& mat )
	{
		camera->Transform(mat);
	}

}}
