#pragma once
#include "Node.h"
#include "../Object.h"
#include <assert.h>

namespace seg { namespace sg {

	enum TraverseBehavior;
	class Node;
	class CameraNode;

	//! V[Ot
	class SEGEXPORT SceneGraph : public Object
	{
	public:
		SceneGraph();
		virtual ~SceneGraph();

		Node* GetTopNode() const {
			return this->topnode_.get();
		}

	private:
		intrptr<Node> topnode_;
	};

	//! r[
	class SEGEXPORT View : public Object
	{
	public:
		explicit View( SceneGraph* psg );
		virtual ~View();

		float GetAspect() const {
			return this->aspect_;
		}
		void SetAspect( float aspect ) {
			this->aspect_ = aspect;
		}
		D3DFILLMODE GetFillMode() const {
			return this->fillmode_;
		}
		void SetFillMode( D3DFILLMODE fm ) {
			this->fillmode_ = fm;
		}

		CameraNode* GetCamera() const {
			return this->camera_.get();
		}

		void Draw();

	private:
		SceneGraph* const sg_;
		float aspect_;
		D3DFILLMODE fillmode_;
		intrptr<CameraNode> camera_;

	private:
		static TraverseBehavior _InitTraverser( Node* node, View* view );
		static TraverseBehavior _DrawTraverser( Node* node, View* view );
	};

}}
