using System;
using System.Runtime.InteropServices;

namespace csharp
{
	class Program
	{
        //[UnmanagedFunctionPointer(CallingConvention.Cdecl)]
		delegate string message();

		[DllImport("unmanaged",EntryPoint="hello")]
		extern static void c_hello( message func );
		
		[DllImport("unmanaged",EntryPoint="hello2")]
		extern static void c_hello2();

		[DllImport("unmanaged",EntryPoint="setmessage")]
		extern static void c_setmessage( message func );

		[DllImport("unmanaged",EntryPoint="say")]
		extern static void c_say();

		static string mymsg()
		{
			return "błB";
		}


		[DllImport("unmanaged",EntryPoint="?New@Human@@SAPAV1@XZ")]
		extern static IntPtr cpp_Human_New();

		[DllImport("unmanaged",EntryPoint="?Delete@Human@@SAXPAV1@@Z")]
		extern static void cpp_Human_Delete( IntPtr context );

		[DllImport("unmanaged",CallingConvention=CallingConvention.ThisCall,EntryPoint="?Greeting@Human@@QAEXXZ")]
		extern static void cpp_Human_Greeting( IntPtr context );

		[DllImport("unmanaged",CallingConvention=CallingConvention.ThisCall,EntryPoint="?SetName@Human@@QAEXPBD@Z")]
		extern static void cpp_Human_SetName( IntPtr context, string name );


		static void Main(string[] args)
		{
			c_hello(mymsg);
			c_hello2();

			IntPtr context = cpp_Human_New();
			cpp_Human_Greeting(context);
			cpp_Human_SetName(context,"񂷂");
			cpp_Human_Greeting(context);
			cpp_Human_Delete(context);

			message dg = new message( mymsg );
			c_setmessage(dg);
			c_say();

			dg = null;
			GC.Collect();
			GC.WaitForPendingFinalizers();

			c_say();
		}
	}
}
