
#include <stdio.h>
#include <memory>

#define DLLEXPORT __declspec(dllexport)
#include "dll.h"

void c_func()
{
	printf("call c_func()\n");
}

void c_init( c_structure* data )
{
	*data = s_structure;
}

c_structure s_structure = {0,1,2,3};

void cpp_func()
{
	printf("call cpp_func()\n");
}

std::auto_ptr<cpp_class> cpp_class::s_singleton;

struct cpp_class::Info
{
	char name[ 32 ];
};

cpp_class::cpp_class()
{
	s_singleton.release();
	s_singleton.reset(this);
	printf("ctor\n");
	this->value_ = s_structure;
	this->info_.reset(new Info);
}
cpp_class::~cpp_class()
{
	s_singleton.release();
	printf("dtor\n");
	s_structure = this->value_;
	this->info_.reset();
}
