using System;
using System.Collections.Generic;
using System.Text;
using squirrel;

namespace sqtest
{
	class Program
	{
		delegate void v_s( string msg, string arg );

		static void Main( string[] args )
		{
			using(VMContext vmc = new VMContext(1024)){
				using(VM.ScopedStack ss = new VM.ScopedStack(vmc)){
					vmc.PushRootTable();
					vmc.PushString("Console");
					vmc.NewTable();
					vmc.Register(
						new v_s(delegate( string msg, string arg ){
							Console.WriteLine(msg,arg); }),
						"WriteLine");
					vmc.NewSlot();
				}
				VMObject writeline = vmc["Console"]["WriteLine"];
				vmc.SetVar("username",Environment.GetEnvironmentVariable("username"));
				VMObject username = vmc["username"];
				vmc.ExecuteString("Console.WriteLine(\"username={0}\",username)");
			}
		}
	}
}
