//	shive's code 2008.08.19
//=============================================================================

#include "stdafx.h"
#include "app.h"
#include "../fwk/Model.h"
#include "../com/debug.h"
#include "../mem/Allocator.h"

namespace shive { namespace hoge {

	using com::tick;
	using com::timer;
	using com::vector;
	using com::matrix;
	using com::degree;
	using com::radian;
	using com::aabb;
	using com::debug;
	using fwk::Gadget;
	using fwk::World;

	#include "console.inl"
	#include "camera.inl"
	#include "grid.inl"

	App::App() {
	}
	App::~App() {
	}

	static HSQUIRRELVM s_sqvm;

	//squirrelprintR[obN
	static void printfunc( HSQUIRRELVM sqvm, const SQChar* fmt, ... )
	{
		char buf[ 2048 ];
		va_list args;
		va_start( args, fmt );
		vsprintf_s( buf, fmt, args );
		va_end( args );
		debug::writeline( buf );
	}

	//
	uint App::init( uint )
	{
		HRESULT hr = 0;

		//XNvg
		s_sqvm = sq_open( 1024 );
		sq_setprintfunc( s_sqvm, printfunc );

		//XNvgR[hseXg
		if(0)
		{
			SQInteger oldtop = sq_gettop( s_sqvm );
			const char* const str = "print(\"hoge\")";
			if( sq_compilebuffer( s_sqvm, str, strlen(str), "", true ) >= 0 ){
				sq_pushroottable( s_sqvm );
				sq_pushstring( s_sqvm, "print", -1 );
				sq_get( s_sqvm, -2 );
				sq_pushroottable( s_sqvm );
				sq_push( s_sqvm, -4 );
				sq_call( s_sqvm, 2, false, true );
			}
			sq_settop( s_sqvm, oldtop );
		}

		//foCX̃ftHgݒ
		device dev;
		hr = dev->SetRenderState( D3DRS_LIGHTING, false );
		hr = dev->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );

		//ReLXgݒ
		this->world_.reset( new World() );
		this->camera_.reset( new Camera( &this->world_->env().camera ) );
		this->grid_.reset( new Grid() );

		return 0;
	}

	//I
	void App::term()
	{
		this->world_.reset();
		this->camera_.reset();
		this->grid_.reset();

		//XNvgI
		sq_close( s_sqvm );
	}

	//`揈
	void App::draw()
	{
		HRESULT hr = 0;

		static timer s_fps;
		Console::instance().WriteLine("DRAW: %.1f FPS",(float)tick::TickPerSecond/s_fps.update().get());

		//ʃNA
		device dev;
		hr = dev->Clear( 0, 0, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER | D3DCLEAR_STENCIL, D3DCOLOR_XRGB(160,160,160), 1.0f, 0 );

		//Jݒ
		this->camera_->Apply();

		//Obh`
		this->grid_->Draw();

		//[h`
		this->world_->Draw();

		//Qc`
		Console::instance().Flush();
	}

	//XViƗXbhĂ΂j
	bool App::update( tick delta )
	{
		//static timer s_fps;
		//Console::instance().WriteLine("UPDATE: %.1f FPS",(float)tick::TickPerSecond/s_fps.update().get());

		//debug::scopedtimer<tick::usec> tm("[update] %d us");

		//JXV
		this->camera_->Update( delta );

		return true;
	}

	//}EX
	bool App::OnMouseMove( uint buttons, const POINT& mpt )
	{
		return this->camera_->OnMouseMove( buttons, mpt );
	}

}}
