//	shive's code 2008.08.19
//=============================================================================

	class Grid : public countable {
	public:
		Grid()
		{
			HRESULT hr = 0;

			debug::scopedtimer<tick::usec> tm("[Grid::ctor] %d us");

			D3DVERTEXELEMENT9 elem[] = {
				{ 0, 0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
				{ 0, 12, D3DDECLTYPE_D3DCOLOR, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_COLOR, 0 },
				D3DDECL_END(),
			};
			hr = device()->CreateVertexDeclaration( elem, &decl );

			const uint brightness = 255;
			ushort counter = 0;
			for( int Li = 0; Li < size; ++Li ){
				for( int Lj = 0; Lj < size; ++Lj ){
					const uint WHITE = D3DCOLOR_XRGB( brightness, brightness, brightness );
					const uint YELLOW = D3DCOLOR_XRGB( brightness, brightness, 0 );
					struct ut {
						static vertex make( int x, int y, uint col ) {
							const vertex data = { (float)x, 0.0f, (float)y, col };
							return data;
						}
					};
					//_
					{
						vertex* const vtx = &vertices[ (Lj + Li * size) * 4 ];
						const uint col = ((Li + Lj) % 2)? YELLOW: WHITE;
						vtx[0] = ut::make( 1 + Li, 0 + Lj, col );
						vtx[1] = ut::make( 1 + Li, 1 + Lj, col );
						vtx[2] = ut::make( 0 + Li, 1 + Lj, col );
						vtx[3] = ut::make( 0 + Li, 0 + Lj, col );
					}
					//CfNX
					{
						ushort* const idx = &indices[ (Lj + Li * size) * 6 ];
						idx[0] = 0 + counter;
						idx[1] = 1 + counter;
						idx[2] = 2 + counter;
						idx[3] = 0 + counter;
						idx[4] = 2 + counter;
						idx[5] = 3 + counter;
						counter += 4;
					}
				}
			}
		};
		void Draw()
		{
			HRESULT hr = 0;

			//debug::scopedtimer<tick::usec> tm("[Grid::Draw] %d us");

			const matrix xmove = matrix::translation(vector::xunit()*-(float)size);
			const matrix zmove = matrix::translation(vector::zunit()*-(float)size);
			const matrix xzmove = xmove * zmove;

			device dev;
			hr = dev->SetVertexDeclaration( decl );
			hr = dev->SetTransform( D3DTS_WORLD, matrix::identity() );
			hr = dev->DrawIndexedPrimitiveUP( D3DPT_TRIANGLELIST, 0, sizeof(vertices)/sizeof(vertices[0]), sizeof(indices)/sizeof(indices[0])/3, indices, D3DFMT_INDEX16, vertices, sizeof(vertices[0]) );
			hr = dev->SetTransform( D3DTS_WORLD, xmove );
			hr = dev->DrawIndexedPrimitiveUP( D3DPT_TRIANGLELIST, 0, sizeof(vertices)/sizeof(vertices[0]), sizeof(indices)/sizeof(indices[0])/3, indices, D3DFMT_INDEX16, vertices, sizeof(vertices[0]) );
			hr = dev->SetTransform( D3DTS_WORLD, zmove );
			hr = dev->DrawIndexedPrimitiveUP( D3DPT_TRIANGLELIST, 0, sizeof(vertices)/sizeof(vertices[0]), sizeof(indices)/sizeof(indices[0])/3, indices, D3DFMT_INDEX16, vertices, sizeof(vertices[0]) );
			hr = dev->SetTransform( D3DTS_WORLD, xzmove );
			hr = dev->DrawIndexedPrimitiveUP( D3DPT_TRIANGLELIST, 0, sizeof(vertices)/sizeof(vertices[0]), sizeof(indices)/sizeof(indices[0])/3, indices, D3DFMT_INDEX16, vertices, sizeof(vertices[0]) );
		}
	private:
		static const uint size = 8;
		comptr<IDirect3DVertexDeclaration9> decl;
		struct vertex {
			float pos[ 3 ];
			uint  col;
		};
		vertex vertices[ size * size * 4 ];
		ushort indices[ size * size * 6 ];
	};
